      SUBROUTINE AXIS ROT (IAX,THETA,ROT)
C
C THIS ROUTINE SETS UP A ROTATION MATRIX WHICH ROTATES THE
C AXIS NUMBERED IAX THROUGH AN ANGLE OF THETA.  THE MATRIX IS
C PUT INTO ROT.  (TO ROTATE AROUND ANOTHER AXIS ALSO USE
C ADDXROT)  ENTRY POINT BODYROT WILL ROTATE THE BODY IN A
C FIXED AXIS.
C
C  INPUT
C
C    IAX   - AXIS TO ROTATE MATRIX AROUND
C    THETA - ANGLE WHICH MATRIX IS ROTATED THROUGH
C
C  OUPUT
C
C    ROT   - ROTATION MATRIX GENERATED 
C
C LAST MODIFIED:
C
C    CONVERTED  USOFT FTN JRC  3/95
C
$INCLUDE:'WRDSIZ.INC'
C
C
C
      DIMENSION ROT(3,3)
C
      DATA  DTR /1.7453 29251 9942D-2/
C
C         -------------------------------------------
C
      THR=DTR*THETA
C
10    CONTINUE
C
      C=COS(THR)
      S=SIN(THR)
C
      DO  40 I = 1, 3
      DO  30 J = 1, 3
         ROT(I,J) = 0.0D0
30    CONTINUE
40    CONTINUE
C
C              FIND THE INDEX'S TO USE -- PERPENDICULAR TO ROT AXIS
C
      ROT(IAX,IAX)=1.0D0
C
      IP1=IAX+1
      IF(IP1.GT.3) IP1=1
      IP2=IP1+1
      IF(IP2.GT.3) IP2=1
C
      ROT(IP1,IP1)=C
      ROT(IP2,IP2)=C
      ROT(IP1,IP2)=S
      ROT(IP2,IP1)=-S
C
      RETURN
      END
$PAGE
      SUBROUTINE BODY ROT (IAX,THETA,ROT)
C
C THIS ROUTINE SETS UP A ROTATION MATRIX WHICH ROTATES THE
C AXIS NUMBERED IAX THROUGH AN ANGLE OF THETA.  THE MATRIX IS
C PUT INTO ROT.  (TO ROTATE AROUND ANOTHER AXIS ALSO USE
C ADDXROT)  ENTRY POINT BODYROT WILL ROTATE THE BODY IN A
C FIXED AXIS.
C
C  INPUT
C
C    IAX   - AXIS TO ROTATE MATRIX AROUND
C    THETA - ANGLE WHICH MATRIX IS ROTATED THROUGH
C
C  OUPUT
C
C    ROT   - ROTATION MATRIX GENERATED 
C
C LAST MODIFIED:
C
C    CONVERTED USOFT FTN JRC 3/95
C
$INCLUDE:'WRDSIZ.INC'
C
C
C
      DIMENSION ROT(3,3)
C
      DATA  DTR /1.7453 29251 9942D-2/
C
C
C         -------------------------------------------
C
      THR = -DTR*THETA
C
10    CONTINUE
C
      C=COS(THR)
      S=SIN(THR)
C
      DO  40 I = 1, 3
      DO  30 J = 1, 3
         ROT(I,J) = 0.0D0
30    CONTINUE
40    CONTINUE
C
C         FIND AXIS PERPENDICULAR TO ROT AXIS, SET IN SIN,COS'S
C
      ROT(IAX,IAX)=1.0
C
      IP1=IAX+1
      IF(IP1.GT.3) IP1=1
      IP2=IP1+1
      IF(IP2.GT.3) IP2=1
C
      ROT(IP1,IP1)=C
      ROT(IP2,IP2)=C
      ROT(IP1,IP2)=S
      ROT(IP2,IP1)=-S
C
      RETURN
      END
$PAGE
      SUBROUTINE ADD X ROT (IAX,THETA,ROT)
C
C THIS ROUTINE TAKES THE ROTATION MATRIX ROT AND FURTHER ROTATES
C IT AROUND THE AXIS IAX FOR THETA DEGREES.  ROT SHOULD BE AN
C IDENTITY MATRIX OR BE INITIALIZED THROUGH A CALL TO AXISROT.
C ADDBROT WILL ROTATE THE BODY INSTEAD OF THE AXIS.
C
C LAST MODIFIED;
C              JRC  3-95 MOVED TO PC
C
C  INPUT
C
C    ROT   - ROTATIONAL MATRIX TO BE FURTHER ROTATED
C    IAX   - AXIS FOR MATRIX TO BE ROTATED AROUND
C    THETA - NUMBER OF DEGREES TO ROTATE ROT
C
C  OUTPUT
C
C    ROT   - ROTATED MATRIX  -  UPDATED
C
C
C         CONVERTED USOFT FTN JRC 3/95
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION ROT(3,3),ROTN(3,3)
C
C         ------------------------------------------
C
      CALL AXISROT (IAX,THETA,ROTN)
      CALL MXM33(ROTN,ROT,ROT)
C
      RETURN
      END
$PAGE
      SUBROUTINE ADD B ROT (IAX,THETA,ROT)
C
C THIS ROUTINE TAKES THE ROTATION MATRIX ROT AND FURTHER ROTATES
C IT AROUND THE AXIS IAX FOR THETA DEGREES.  ROT SHOULD BE AN
C IDENTITY MATRIX OR BE INITIALIZED THROUGH A CALL TO AXISROT.
C ADDBROT WILL ROTATE THE BODY INSTEAD OF THE AXIS.
C
C LAST MODIFIED;
C              JRC 3-95 MOVED TO PC
C
C  INPUT
C
C    ROT   - ROTATIONAL MATRIX TO BE FURTHER ROTATED
C    IAX   - AXIS FOR MATRIX TO BE ROTATED AROUND
C    THETA - NUMBER OF DEGREES TO ROTATE ROT
C
C  OUTPUT
C
C    ROT   - ROTATED MATRIX  UPDATED
C
C
C         CONVERTED USOFT FTN JRC 3/95
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION ROT(3,3),ROTN(3,3)
C
C         ------------------------------------------
C
      CALL BODYROT (IAX,THETA,ROTN)
      CALL MXM33(ROTN,ROT,ROT)
C
      RETURN
      END
