      SUBROUTINE EDTRBS ( N, EGOOD,EBAD,VAL,NGOOD, IXV )
C
C         EDIT VECTOR ROBUSTLY
C
C         USES ORDINAL STATISTICS 
C              DISTANCE FROM MEDIAN
C              IF .GT. 3 SIGMA FROM MEDIAN, THEN FLAG BAD
C              IF POINTS EDITED, ITERATE
C              CAN DECLARE VALUE LEVELS ABSOLUTELY GOOD,BAD
C
C    INPUT:
C         N         I*4       NUMBER OF ELEMENTS
C         EGOOD     R*8       DIFFERENCE = GOOD NO MATTER SIGMA
C         EBAD      R*8       DIFFERENCE = BAD  "    "     "
C         VAL(N)    R*8       THE DATA
C
C    OUTPUT:
C         NGOOD     I*4       NUMBER GOOD
C         IXV(N)    I*4       FLAGS,  NEGATIVE = BAD, .GT.0 GOOD
C
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION   VAL(*), IXV(*)
C
      DATA  ABSMAX /1.0D10/
C
C         ---------------------------------------
C
      NG  =  0
      IF ( N.LE.0  ) GOTO 900
C
C         1 OR TWO, JUST SAY ALL GOOD
C
      IF ( N.LE.2  ) THEN
          DO 50 I=1,N
             IXV(I) = 1
50        CONTINUE
          NG  = N
          GOTO 900
      ENDIF
C
C         POINTER SORT THE ARRAY - USE IXV TO STORE
C
      CALL PSRTR8 ( N, VAL, IXV )
C
      NCYCLE = 0
C
100   CONTINUE
C
      NCYCLE  =  NCYCLE + 1
      IF( NCYCLE.GE.4 ) GOTO 900
C
C         COMPUTE THE SIGMA FOR 5*SIGMA EDITING
C         ONLY USE DATA NOT EDITED LAST CYCLE
C
      XSUM   = 0.0D0
      XXSUM  = 0.0D0
      NUSE   = 0.0D0
C
      NBIG   =  0
C
      DO   120  I=1, N
        IXN     = IXV(I)
        IF ( IXN.GT.0) THEN
           V     = VAL(IXN)
           IF ( ABS(V).GE.ABSMAX) THEN
               NBIG = NBIG + 1
               GOTO 120
           ENDIF
           XSUM  = XSUM  + V
           XXSUM = XXSUM + V**2
           NUSE  = NUSE  + 1
        ENDIF
120   CONTINUE
C
C         ABSOLUTE MEDIAN USED. ALWAYS SAME REFERENCE VALUE
C         EDITING DOESN'T CHANGE THIS VALUE
C
      NREAL =  N - NBIG
      IF ( NREAL.LE.2 ) GOTO 900
C
      MID   =  (NREAL+1)/2
      IXM   =  IXV(MID)
      XMID  =  VAL(IXM)
C
C
200   CONTINUE
C
      IF ( NUSE.LE.0 ) GOTO 900
C
C              VAR, SIGMA ( USE, N NOT N-1 )
C
      FN    = NUSE
      AVG   = XSUM/FN
      VAR   = (XXSUM -FN*AVG*AVG)/FN
      SIG   = SQRT (ABS(VAR))
C
      ELIM  =  3.0D0 * SIG
C
C         SCAN ENTIRE ARRAY AND EDIT BY CRITERIA
C
      NG    =  0
      ICHG  =  0
      DO  300  IXX = 1, N
C
          IXN = IXV(IXX)
          ILSTAT  = 1
          IF ( IXN.LT.0 ) ILSTAT = 0
C
          IX  = IABS( IXN ) 
          V   = VAL(IX)
          DIF =  ABS ( V - XMID )
C
          IGOOD =  1
          IF ( DIF.GT.EBAD ) IGOOD = 0
          IF ( DIF.GT.ELIM ) IGOOD = 0
          IF ( DIF.LT.EGOOD) IGOOD = 1
C
          IF ( IGOOD .EQ. 1 ) THEN
              IXV(IXX)  =  IX
              NG        =  NG + 1
          ELSE
              IF ( IGOOD.NE.ILSTAT ) ICHG = 1
              IXV(IXX)  = -IX
          ENDIF
C
300   CONTINUE
C
C
      IF ( NG.LE.2 ) GOTO 900
C
C
      IF ( ICHG.NE.0 ) GOTO 100
C
      GOTO 900
C
C
900   CONTINUE
C
      NGOOD  = NG
C
      RETURN
      END
