      SUBROUTINE LAG3V ( LEN,IXX, ARRAY, X, VOUT )
C
C         COMPUTE LAGRANGIAN 3 POINT INTERPOLATION FOR 
C         MULTIPLE ITEMS IN A VECTOR.
C
C    MODHIST:
C              1-10-96   JRC CODED
C
C    INPUT:
C              LEN       I*4       LENGTH OF EACH VECTOR
C              IXX       I*4       INDEX OF INDEPENDENT VAR ( IE X)
C              ARRAY(LEN,3) R*8    DATA ARRAY -- ONLY 3 VECTORS
C                                                (ASSUME CALLER ALIGNS)
C              X         R*8        X VALUE TO FIND
C              VOUT(LEN) R*8        INTERPOLATED EACH ELEMENT EXCEPT
C                                   ELEMENT IXX WHICH IS SET TO X
C
C              --  UNPREDICTABLE IF ERROR  EG. LEN.LT.2 OR IXX.GT.LEN
C
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION  ARRAY(LEN,3), VOUT(LEN)
C
C
C         ------------------------------------------------------
C
      IF ( LEN.LE.1 ) GOTO 900
      IF ( IXX.LE.0 .OR. IXX.GT.LEN ) GOTO 900
C
C         FORM THE COEFICIENTS VIA LAGANGIAN FORMULA
C
      XM  = ARRAY( IXX,1)
      XZ  = ARRAY( IXX,2)
      XP  = ARRAY( IXX,3)
C
      DM  =  XZ - XM
      DP  =  XP - XZ
      DS  =  XP - XM
C
      IF ( ABS(DM).LT.1.0D-10 ) GOTO 900
      IF ( ABS(DP).LT.1.0D-10 ) GOTO 900
      IF ( ABS(DS).LT.1.0D-10 ) GOTO 900
C
      DXM  =  X-XM
      DXZ  =  X-XZ
      DXP  =  X-XP
C
      COEFM =    DXZ*DXP/(DM*DS)
      COEFZ =  - DXM*DXP/(DM*DP)
      COEFP =    DXM*DXZ/(DS*DP)
C
      DO  100 I = 1, LEN
        IF ( I.EQ. IXX ) THEN
           VOUT(I) = X
        ELSE
           YM = ARRAY ( I,1 )
           YZ = ARRAY ( I,2 )
           YP = ARRAY ( I,3 )
           VOUT(I)  =  COEFM*YM + COEFZ*YZ + COEFP*YP
        ENDIF
100   CONTINUE
C
C
900   CONTINUE
C
      RETURN
      END
$PAGE
      SUBROUTINE LAG3XV ( LEN,XA, ARRAY, X, VOUT )
C
C         COMPUTE LAGRANGIAN 3 POINT INTERPOLATION FOR 
C         MULTIPLE ITEMS IN A VECTOR.
C
C    MODHIST:
C              1-10-96   JRC CODED
C
C    INPUT:
C              LEN       I*4       LENGTH OF EACH VECTOR
C              XA        R*8       XVALUES ARRAY LENGTH 3 
C              ARRAY(LEN,3) R*8    DATA ARRAY -- ONLY 3 VECTORS
C                                        (ASSUME CALLER ALIGNS)
C              X         R*8        X VALUE TO FIND
C              VOUT(LEN) R*8        INTERPOLATED EACH ELEMENT EXCEPT
C
C              --  UNPREDICTABLE IF ERROR  EG. LEN.LT.2 OR IXX.GT.LEN
C
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION  XA(LEN), ARRAY(LEN,3), VOUT(LEN)
C
C
C         ------------------------------------------------------
C
      IF ( LEN.LE.1 ) GOTO 900
C
C         FORM THE COEFICIENTS VIA LAGANGIAN FORMULA
C
      XM  = XA( 1 )
      XZ  = XA (2 )
      XP  = XA (3 )
C
      DM  =  XZ - XM
      DP  =  XP - XZ
      DS  =  XP - XM
C
      IF ( ABS(DM).LT.1.0D-10 ) GOTO 900
      IF ( ABS(DP).LT.1.0D-10 ) GOTO 900
      IF ( ABS(DS).LT.1.0D-10 ) GOTO 900
C
      DXM  =  X-XM
      DXZ  =  X-XZ
      DXP  =  X-XP
C
      COEFM =    DXZ*DXP/(DM*DS)
      COEFZ =  - DXM*DXP/(DM*DP)
      COEFP =    DXM*DXZ/(DS*DP)
C
      DO  100 I = 1, LEN
           YM = ARRAY ( I,1 )
           YZ = ARRAY ( I,2 )
           YP = ARRAY ( I,3 )
           VOUT(I)  =  COEFM*YM + COEFZ*YZ + COEFP*YP
100   CONTINUE
C
C
900   CONTINUE
C
      RETURN
      END
