$TITLE:'MINVRT'
$PAGESIZE: 63
         SUBROUTINE MINVRT
     1                  (N   , A , KA , D , IERR)
C
C        ***************************************************************
C        GAUSS-JORDAN PROCEDURE FOR INVERTING MATRICES/SOLVING EQUATIONS
C        ***************************************************************
         DOUBLE PRECISION A , D , T , SWAP , PIVOT
         DIMENSION A(1)
         DIMENSION IPIVOT(6), INDEX(6,2)
         INTEGER*2        N, KA, IERR, I, J, K, JK, JL, KL, MAXA
         INTEGER*2        IPIVOT, INDEX, IROW, ICOLUM, ICOL
         INTEGER*2        L, IL, I1, KCOL, LCOL
C        ------------------------
         IERR = 0
         IF (1.LE.N.AND.N.LE.6) GO TO 10
         IERR = 1
         RETURN
   1     IERR = 2
         RETURN
C
C        INITIALIZATION
C
  10     MAXA = KA*N
         DO 11 J=1,N
  11     IPIVOT(J) = 0
         DO 63 I=1,N
C
C        SEARCH FOR THE NEXT PIVOT ELEMENT
C
         PIVOT = 0.D0
         DO 21 J=1,N
         IF (IPIVOT(J).EQ.1) GO TO 21
         JK = J
         DO 20 K=1,N
         IF (IPIVOT(K).EQ.1) GO TO 20
         IF (DABS(PIVOT).GE.DABS(A(JK))) GO TO 20
         IROW = J
         ICOLUM = K
         PIVOT = A(JK)
  20     JK = JK + KA
  21     CONTINUE
         D = D*PIVOT
         IF (PIVOT) 30,1,30
C
C        INTERCHANGE ROWS TO PUT PIVVOT ELEMENT ON DIAGONAL
C
  30     IPIVOT(ICOLUM) = 1
         ICOL = (ICOLUM-1)*KA
         INDEX(I,1) = ICOL
         INDEX(I,2) = ICOL
         IF (IROW.EQ.ICOLUM) GO TO 50
         D = -D
         INDEX(I,1) = (IROW-1)*KA
C
         JL = IROW
         KL = ICOLUM
         DO 40 L=1,N
         SWAP = A(JL)
         A(JL) = A(KL)
         A(KL) = SWAP
         JL = JL + KA
  40     KL = KL + KA
C
C        DIVIDE THE PIVOT ROW BY THE PIVOT ELEMENT
C
  50     A(ICOL+ICOLUM) = 1.0D0
         DO 51 IL=ICOLUM,MAXA,KA
  51     A(IL) = A(IL)/PIVOT
C
C        REDUCE THE NON-PIVOT ROWS
C
  60     DO 63 J=1,N
         IF (J.EQ.ICOLUM) GO TO 63
         T = A(ICOL+J)
         A(ICOL+J) = 0.D0
         IL = ICOLUM
         JL = J
         DO 61 L=1,N
         A(JL) = A(JL) - A(IL) *T
         IL = IL + KA
  61     JL = JL + KA
  63     CONTINUE
C
C        INTERCHANGE THE COLUMNS
C
         I1 = N
         DO 71 I=1,N
         KCOL = INDEX(I1,1)
         LCOL = INDEX(I1,2)
         IF (KCOL.EQ.LCOL) GO TO 71
         DO 70 J=1,N
         JK = J+KCOL
         JL = J+LCOL
         SWAP = A(JK)
         A(JK) = A(JL)
  70     A(JL) = SWAP
  71     I1 = I1 -1
C
         RETURN
         END
