$TITLE:'MEAN LEAST SQUARES'
$SUBTITLE:'OMLS-INIT'
        SUBROUTINE IOMLS ( NPARMS ,IER ) 
C
C        INITIALIZE  O-M-L-S
C
C         NPARMS   = NUMBER OF PARAMETERS
C         IER      =  0 OKAY, 1 IF OUT OF RANGE
C         (CURRENTLY  15 MAX NUMBER OF PARAMETERS)
C
$INCLUDE:'WRDSIZ.INC'
C
$INCLUDE:'MLS.INC'
C
C 
        NPT    =    0 
        NPAR   =  - 1
C
        IER     =   0
        IF ( NPARMS .LE. 0 )    IER  = 1
        IF ( NPARMS .GT. MXIX ) IER  = 1
        IF ( IER .NE. 0 ) GOTO 900
C
        NPAR  =  NPARMS
C
C        
        IX    = 1
C
        DO 400 I=1,MXIX 
C
        D(I)=0. 
C
        DO 300 J=1,MXIX 
C
        PM(IX)  =  0.
        COV(IX) =  0.
C
        IX      =  IX  + 1
C 
300     CONTINUE
400     CONTINUE
C 
900     CONTINUE
C 
        RETURN
        END
$PAGE
$SUBTITLE:'OMLS DATA ENTRY'
        SUBROUTINE OMLS ( Y, P )
C 
C     ORDINARY MEAN LEAST SQUARES ROUTINE 
C
C     OMLS IS DATA ADDITION ENTRY POINT 
C               P(1-N) IS THE PARTIALS MATRIX 
C               Y      IS MEASUREMENT - SCALAR
C 
C       MAXIMUM OF 15 PARAMETERS
C 
$INCLUDE:'WRDSIZ.INC'
C
        DIMENSION P(15) 
C 
$INCLUDE:'MLS.INC'
C
C 
        IF ( NPAR .LE. 0 ) GOTO 900
C
        DO 200 I= 1, NPAR
C
        D(I) = D(I) + P(I)*Y
        JB   =   I 
        IX   =   I + NPAR * ( JB - 1 )
C
        DO 100 J=JB,NPAR 
C
        PM(IX) = PM(IX) + P(I)*P(J)
        IX     = IX   + NPAR
C
100     CONTINUE
200     CONTINUE
C 
        NPT    =  NPT + 1 
C 
900     CONTINUE
C
        RETURN
        END
$PAGE
$SUBTITLE:'OMLS-RESULTS'
        SUBROUTINE  ROMLS  ( RESULT , IER )
C
C          RESULTS OF O-M-L-S   CALCULATIONS
C 
C          RESULTS   = OUTPUT VECTOR
C          IER       =  0   OKAY
C                       1   INVALID SETUP
C                       2   NOT ENOUGH DATA
C                      10+  MATRIX INVERSION ERROR
C
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION RESULT ( 15 )
C
$INCLUDE:'MLS.INC'
C 
        IER     =  1
        IF ( NPAR .LE. 0 ) GOTO 900
C
        IER     =  2 
        IF(NPT.LT.1) GOTO 900 
C
        IER     =  0
C
C       ACCUMULATES ONLY HALF OF PARTIALS MATRIX
C       FILL IT IN
C 
        DO 450 I=1,NPAR
C
        JE=I
C
        DO 440 J=1,JE 
C        
        IX1    =   J   +  NPAR * ( I - 1 )
        IX2    =   I   +  NPAR * ( J - 1 )
C
        PM(IX2)  =   PM(IX1)
C
440     CONTINUE
450     CONTINUE
C
C
C        MOVE PARTIALS TO COV FOR IN PLACE INVERSE
C
       NMOVE  = NPAR * NPAR
       DO 460 I = 1, NMOVE
       COV ( I ) =  PM ( I )
460    CONTINUE
C
C       IN PLACE INVERSE OF PARTIALS MATRIX IN COV
C 
       CALL  MXIVRT ( NPAR, COV, DETR, IERR )
       IF ( IERR .NE. 0 ) IER = IERR + 10
       IF ( IERR .NE. 0 ) GOTO 900
C
C          MULT INVERSE TIME SAVED RESIDUALS TIMES PARTIALS
C
        DO 600 I= 1,NPAR
C
        S=0.
        DO 590 J= 1,NPAR
C
        IX   =  I + NPAR * ( J - 1 )
        S    =  S + COV(IX)*D(J)

590     CONTINUE
C
        RESULT(I)= S 
C
600     CONTINUE
C 
900     CONTINUE
        RETURN
        END 
$SUBTITLE:'WMLS-INIT'
        SUBROUTINE IWMLS ( NPARMS ,IER ) 
C
C        INITIALIZE  W-M-L-S
C
C         NPARMS   = NUMBER OF PARAMETERS
C         IER      =  0 OKAY, 1 IF OUT OF RANGE
C         (CURRENTLY  15 MAX NUMBER OF PARAMETERS)
C
$INCLUDE:'WRDSIZ.INC'
C
$INCLUDE:'MLS.INC'
C
C 
        NPT    =    0 
        NPAR   =  - 1
C
        IER     =   0
        IF ( NPARMS .LE. 0 )    IER  = 1
        IF ( NPARMS .GT. MXIX ) IER  = 1
        IF ( IER .NE. 0 ) GOTO 900
C
        NPAR  =  NPARMS
C
C        
        IX    = 1
C
        DO 400 I=1,MXIX 
C
        D(I)=0. 
C
        DO 300 J=1,MXIX 
C
        PM(IX)  =  0.
        COV(IX) =  0.
C
        IX      =  IX  + 1
C 
300     CONTINUE
400     CONTINUE
C 
900     CONTINUE
C 
        RETURN
        END
$PAGE
$SUBTITLE:'WMLS DATA ENTRY'
        SUBROUTINE WMLS ( Y, P, W )
C 
C     WEIGHTED MEAN LEAST SQUARES ROUTINE 
C
C     WMLS IS DATA ADDITION ENTRY POINT 
C               P(1-N) IS THE PARTIALS MATRIX 
C               Y      IS MEASUREMENT - SCALAR
C               W      IS WEIGHT THIS MEASUREMENT
C 
C       MAXIMUM OF 15 PARAMETERS
C 
$INCLUDE:'WRDSIZ.INC'
C
        DIMENSION P(15) 
C 
$INCLUDE:'MLS.INC'
C
C 
        IF ( NPAR .LE. 0 ) GOTO 900
C
        DO 200 I= 1, NPAR
C
        D(I) = D(I) + P(I)*W*Y
        JB   =   I 
        IX   =   I + NPAR * ( JB - 1 )
C
        DO 100 J=JB,NPAR 
C
        PM(IX) = PM(IX) + P(I)*W*P(J)
        IX     = IX   + NPAR
C
100     CONTINUE
200     CONTINUE
C 
        NPT    =  NPT + 1 
C 
900     CONTINUE
C
        RETURN
        END
$PAGE
$SUBTITLE:'WMLS-RESULTS'
        SUBROUTINE  RWMLS  ( RESULT , IER )
C
C          RESULTS OF W-M-L-S   CALCULATIONS
C 
C          RESULTS   = OUTPUT VECTOR
C          IER       =  0   OKAY
C                       1   INVALID SETUP
C                       2   NOT ENOUGH DATA
C                      10+  MATRIX INVERSION ERROR
C
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION RESULT ( 15 )
C
$INCLUDE:'MLS.INC'
C 
        IER     =  1
        IF ( NPAR .LE. 0 ) GOTO 900
C
        IER     =  2 
        IF(NPT.LT.1) GOTO 900 
C
        IER     =  0
C
C       ACCUMULATES ONLY HALF OF PARTIALS MATRIX
C       FILL IT IN
C 
        DO 450 I=1,NPAR
C
        JE=I
C
        DO 440 J=1,JE 
C        
        IX1    =   J   +  NPAR * ( I - 1 )
        IX2    =   I   +  NPAR * ( J - 1 )
C
        PM(IX2)  =   PM(IX1)
C
440     CONTINUE
450     CONTINUE
C
C        MOVE PARTIALS TO COV FOR IN PLACE INVERSE
C
       NMOVE  = NPAR * NPAR
       DO 460 I = 1, NMOVE
       COV ( I ) =  PM ( I )
460    CONTINUE
C
C       IN PLACE INVERSE OF PARTIALS MATRIX IN COV
C 
       CALL  MXIVRT ( NPAR, COV, DETR, IERR )
       IF ( IERR .NE. 0 ) IER = IERR + 10
       IF ( IERR .NE. 0 ) GOTO 900
C
C          MULT INVERSE TIME SAVED RESIDUALS TIMES PARTIALS
C
        DO 600 I= 1,NPAR
C
        S=0.
        DO 590 J= 1,NPAR
C
        IX   =  I + NPAR * ( J - 1 )
        S    =  S + COV(IX)*D(J)

590     CONTINUE
C
        RESULT(I)= S 
C
600     CONTINUE
C 
900     CONTINUE
        RETURN
        END 
$PAGE
$SUBTITLE:'RETURN COVAR'
      SUBROUTINE COVMLS ( P, IER )
C
C         RETURN CO-VARIANCE MATRIX -- OR HTH
C
C  INPUT:
C              ----------------------------------------------------------
C              -- MUST HAVE SET UP AND RUN INIT., DATA INPUT, AND RESULTS
C                 OF ONE OF OMLS, WMLS, MAPLS
C
C  OUTPUT:
C
C              P(NPAR,NPAR)   R*8       COVARIANCE MATRIX
C              IER            I*4       0 OKAY, 1 ERROR
C
C
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION   P(*)
C
$INCLUDE:'MLS.INC'
C
C
C    -------------------------------------------------------------
C
      IERR = 1
      IF ( NPAR.LE.0 ) GOTO 900
C
C     
      IERR  = 0
C
      DO   240  I = 1, NPAR
        DO 220  J = 1, NPAR
C
            IX  = I + NPAR*(J-1)
C
            P(IX)  = COV(IX)
C
220     CONTINUE
240   CONTINUE
C
900   CONTINUE
C
      IER  = IERR
      RETURN
      END
$PAGE
$SUBTITLE:'M.A.P ROUTINES'
        SUBROUTINE IMAPLS ( NPARMS, XZ,PZ,IER )
C
C     MAXIMUM A POSTERIORI ESTIMATE ROUTINE
C
C     INPUT:
C              NPARMS    I*4       NUMBER PARMS. 1 TO 15
C              XZ (.)    R*8       A PRIORI STATE 
C              PZ (.,.)  R*8       A PRIORI COVARIANCE
C     OUTPUT:
C              IER       I*4       0 OKAY, 1 PARM. OUT OF RANGE,
C                                  2 CAN'T INVERT PZ
C
C         REALY ML METHOD WITH INITIALIZED STORAGE MATRIX
C
C              HT*R**-1 *H   AS     PZ**-1
C              HT*R**-1*Y    AS     PZ**-1 * XZ
C
C
C     MEASUREMENT WEIGHTS ARE ASSUMED TO BE  UNCORRELATED
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION  XZ(NPARMS), PZ (NPARMS,NPARMS)
C
$INCLUDE:'MLS.INC'
C
C
C              ------------------------------------------
C
C
C
        NPT      = 0
        NPAR     = -1
C
        IER    =  0
C
        IF ( NPARMS.LE.0 .OR. NPARMS.GT.MXIX ) IER = 1
        IF ( IER.NE.0 ) GOTO 900
C
        NPAR =  NPARMS
C
C        
        IX    = 1
C
C              CLEAR STORAGE MATRIX'S
C
        DO 400 I=1,MXIX 
          D(I)=0. 
          DO 300 J=1,MXIX 
             PM(IX)  =  0.
             COV(IX) =  0.
             IX      =  IX  + 1
300       CONTINUE
400     CONTINUE
C
C         MOVE PZ INTO PM AND INVERT
C
        IXM = 0
        DO 420 J=1,NPAR
             DO 410 I=1,NPAR
                  IXM = IXM + 1
                  PM ( IXM )  = PZ (I,J)
410         CONTINUE
420     CONTINUE
C
      CALL MXIVRT ( NPAR, PM, DETR, IERR )
      IF ( IERR.NE.0 ) THEN
          IER  = 2
          GOTO 900
      ENDIF
C
C         NOW DO INIT OF  H*R**-1 * Y   ( D,  ALREADY 0 )
C
      DO  520  I = 1, NPAR
         S = 0
         DO  510 J = 1, NPAR
           IX =  I  +  NPAR * (J-1)
           S  =  S  +  PM(IX) * XZ(J)
510      CONTINUE
      D(I)  = S
520   CONTINUE
C
C
      IER  = 0
C 
900   CONTINUE
C
      RETURN
      END
$PAGE
      SUBROUTINE MAPLS(Y,P,W)
C
C     MAXIMUM A POSTERIORI ESTIMATE ROUTINE
C
C 
C     MAPLS IS DATA ADDITION ROUTINE FOR M.A.P ESTIMATOR
C
C    INPUT:
C                      COMMON MUST BE SET UP VIA IMAPLS
C
C               Y        R*8      MEASUREMENT - SCALAR
C               P(1-N)   R*8      PARTIALS VECTOR (NPAR LONG)
C               W        R*8      MEASUREMENT WEIGHT
C
C    ( IDENTICAL TO M.L. -- IE WEIGHTED -- VERSION, DIFFERNCE IN INIT.)
C
C     MEASUREMENT WEIGHTS ARE ASSUMED TO BE
C     UNCORRELATED
C
C     APRIORI UNCERTAINTIES ARE ASSUMED
C     TO BE UNCORRELATED
C
C
$INCLUDE:'WRDSIZ.INC'
C
        DIMENSION P(*)
C
$INCLUDE:'MLS.INC'
C
C              ------------------------------------------------
C
      IF ( NPAR.LE.0 ) GOTO 900
C
C
      DO 200 I= 1, NPAR
C
        D(I) = D(I) + P(I)*W*Y
        JB   =   I 
        IX   =   I + NPAR * ( JB - 1 )
C
        DO 100 J=JB,NPAR 
C
           PM(IX) = PM(IX) + P(I)*W*P(J)
           IX     = IX   + NPAR
C
100     CONTINUE
200   CONTINUE
C 
C
        NPT=NPT+1
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MAP-RESULTS'
        SUBROUTINE  RMAPLS  ( RESULT , IER )
C
C          RESULTS OF M-A-P-L-S   CALCULATIONS
C
C       RMAPLS IS RESULT ENTRY POINT
C               RESULT ( 1..N)  IS A POSTERIORI PARAMETER ESTIMATE
C 
C          RESULTS   = OUTPUT VECTOR
C          IER       =  0   OKAY
C                       1   INVALID SETUP
C                       2   NOT ENOUGH DATA
C                      10+  MATRIX INVERSION ERROR
C
C    ( IDENTICAL TO M.L. -- IE WEIGHTED -- VERSION, DIFFERNCE IN INIT.)
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION RESULT ( 15 )
C
$INCLUDE:'MLS.INC'
C         -------------------------------------------------------
C 
        IER     =  1
        IF ( NPAR .LE. 0 ) GOTO 900
C
        IER     =  2 
        IF(NPT.LT.1) GOTO 900 
C
        IER     =  0
C
C       ACCUMULATES ONLY HALF OF PARTIALS MATRIX
C       FILL IT IN
C 
        DO 450 I=1,NPAR
           JE=I
           DO 440 J=1,JE 
              IX1    =   J   +  NPAR * ( I - 1 )
              IX2    =   I   +  NPAR * ( J - 1 )
              PM(IX2)  =   PM(IX1)
440        CONTINUE
450     CONTINUE
C
C        MOVE PARTIALS TO COV FOR IN PLACE INVERSE
C
       NMOVE  = NPAR * NPAR
       DO 460 I = 1, NMOVE
           COV ( I ) =  PM ( I )
460    CONTINUE
C
C       IN PLACE INVERSE OF PARTIALS MATRIX IN COV
C 
       CALL  MXIVRT ( NPAR, COV, DETR, IERR )
       IF ( IERR .NE. 0 ) IER = IERR + 10
       IF ( IERR .NE. 0 ) GOTO 900
C
C          MULT INVERSE TIME SAVED RESIDUALS TIMES PARTIALS
C
        DO 600 I= 1,NPAR
           S=0.
           DO 590 J= 1,NPAR
              IX   =  I + NPAR * ( J - 1 )
              S    =  S + COV(IX)*D(J)
590        CONTINUE
           RESULT(I)= S 
600     CONTINUE
C 
900     CONTINUE
        RETURN
        END 
