$TITLE:'MATRIX GENERAL ROUTINES'
$SUBTITLE:'MULTIPLY MATRIX * MATRIX'
      SUBROUTINE MXMUL ( L,M,N, A,B,C )
C
C     MATRIX MULTIPLY
C
C       C ( L,N )  = A (L,M) * B ( M,N )
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(L,M), B(M,N), C(L,N)
C
      DO  300 I = 1, L
      DO  200 J = 1, N
C
      SUM = 0.0D0
C
      DO 100 K = 1,M
C
      SUM = SUM + A (I,K) * B(K,J)
C
100   CONTINUE
C
      C ( I,J )  = SUM
C
200   CONTINUE
300   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX TIME VECTOR'
      SUBROUTINE MXVMUL ( M,N, A,B,C )
C
C     MATRIX MULTIPLY TIMES VECTOR   
C
C       C ( M )  = A (M,N) * B ( N )  
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(M,N), B(N), C(M)
C
      DO  300 I = 1, M
C
      SUM = 0.0D0
C
      DO 100 K = 1, N
C
      SUM = SUM + A (I,K) * B(K)
C
100   CONTINUE
C
      C ( I )  = SUM
C
300   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX MULTIPLY TIMES TRANSPOSE'
      SUBROUTINE MXTMUL ( L,M,N, A,B,C )
C
C     MATRIX MULTIPLY
C
C       C ( L,N )  = A (L,M) * B ( N,M ) T
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(L,M), B(N,M), C(L,N)
C
      DO  300 I = 1, L
      DO  200 J = 1, N
C
      SUM = 0.0D0
C
      DO 100 K = 1,M
C
      SUM = SUM + A (I,K) * B(J,K)
C
100   CONTINUE
C
      C ( I,J )  = SUM
C
200   CONTINUE
300   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'TRANSPOSE MATRIX'
      SUBROUTINE MXTRNP ( M,N, A, B )
C
C     TRANSPOSE MATRIX A(M,N)  INTO  B ( N,M )
C     -- CAN NOT USE INPUT AS OUTPUT
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION  A(M,N), B ( N,M)
C
C
      DO  200 I = 1, M
      DO  100 J = 1, N
C
      B( J,I)  = A ( I,J )
C
100   CONTINUE
200   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'TRACE ROUTINE '
      FUNCTION TRACE ( N, ARRAY )
C
C     FIND TRACE OF SQUARE ARRAY  ( N X  N )
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION ARRAY(N,N)
C
      SUM = 0.0D0
C
      DO 100 I = 1, N
C
      SUM = SUM + ARRAY(I,I)
C
100   CONTINUE
C
      TRACE = SUM
C
      RETURN
      END
$PAGE
$SUBTITLE:'SET MATRIX TO A VALUE'
      SUBROUTINE MXSET ( N,M,ARRAY, VALUE)
C
C      SET MATRIX ARRAY(N,M) TO VALUE IN ALL PLACES
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION ARRAY ( N,M )
C
      DO 200 I = 1,N
      DO 100 J = 1,M
C
      ARRAY(I,J) = VALUE
C
100   CONTINUE
200   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'CLEAR MATRIX TO ZERO'
      SUBROUTINE MXCLR ( N,M,ARRAY)
C
C      SET MATRIX ARRAY(N,M) TO ZERO  IN ALL PLACES
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION ARRAY ( N,M )
C
      DO 200 I = 1,N
      DO 100 J = 1,M
C
      ARRAY(I,J) = 0.0D0 
C
100   CONTINUE
200   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'SET SQUARE MATRIX TO IDENTITY'
      SUBROUTINE  MXIDNT ( N, ARRAY )
C
C     SET MATRIX ARRAY(N,N) TO IDENTITY MATRIX
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION ARRAY(N,N)
C
      CALL MXCLR ( N,N, ARRAY )
C
      DO 100 I = 1, N
C
      ARRAY(I,I)  = 1.0D0
C
100   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MAKE DIAGNAL MATRIX FROM VECTOR'
      SUBROUTINE MAKDMX ( N, DIAGV, DIAGMX )
C
C     MAKE VECTOR DIAGV(1..N) INTO DIAGNAL MATRIX DIAGM(N,N)
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION DIAGV(N), DIAGMX(N,N)
C
      CALL MXCLR ( N,N, DIAGMX )
C
      DO 100 I= 1, N
C
      DIAGMX(I,I)  = DIAGV ( I )
C
100   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'EXTRACT DIAGNAL OF MATRIX INTO VECTOR'
      SUBROUTINE GETDIAG ( N, DIAGMX, DIAGV )
C
C     GET DIAGNAL OF MATRIX AND PLACE IT INTO A VECTOR
C     MATRIX  DIAGMX ( N,N )
C     VECTOR  DIAGV  (N)
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION DIAGMX(N,N), DIAGV(N)
C
      DO 100 I = 1, N
C
      DIAGV(I)  = DIAGMX(I,I)
C
100   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'SCALER TIMES GENERAL VECTOR'
      SUBROUTINE SXVEC ( N, S, VIN, VOUT )
C
C      SCALER TIMES VECTOR OF GENERAL LENGTH
C
C      INPUT:
C             N      DIMENSION OF VECTOR
C             S      SCALER
C             VIN    (1..N)  = INPUT VECTOR
C             VOUT             OUTPUT VECTOR
C
C       -- INPUT CAN EQUAL OUTPUT --
C
C     ( EXIT NO WORK IF N.LE.0 )
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION  VIN(N), VOUT(N)
C
      IF ( N .LE. 0 ) GOTO 900
C
      DO 100 I = 1, N
C
      VOUT(I) = S * VIN(I)
C
100   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'SCALER TIMES GENERAL MATRIX'
      SUBROUTINE SXMX  ( M,N, S, AIN, AOUT )
C
C      SCALER TIMES VECTOR OF GENERAL LENGTH
C
C      INPUT:
C             M      FIRST DIM. OF AIN/AOUT
C             N      2ND DIMENSION OF AIN/AOUT
C             S      SCALER
C             AIN(M,N)  INPUT ARRAY
C             AOUT(M,N) OUTPUT ARRAY
C
C          -- INPUT CAN EQUAL OUTPUT --
C
C     ( EXIT NO WORK IF N.LE.0  OR M.LE.0 )
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION  AIN(M,N), AOUT(M,N)
C
      IF ( N .LE. 0 .OR. M .LE. 0 ) GOTO 900
C
      DO 200 I = 1, M
      DO 100 J = 1, N
C
      AOUT( I,J )  =  S * AIN( I,J )
C
100   CONTINUE
200   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX ADD'
      SUBROUTINE MXADD( N,M, A,B,C )
C
C        MATRIX ADD
C
C     INPUT:
C              N,M       I*4   MATRIX SIZE
C              A         R*8   OF SIZE NxM
C              B         R*8   OF SIZE NxM
C     OUTPUT
C              C         R*8   C = A + B     ,    SIZE NxM
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION   A(*),B(*), C(*)
C
C
      NELM  =  N*M
C
      DO   100 I=1, NELM
C
        C(I) = A(I) + B(I)
C
 100  CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX SUB. '
      SUBROUTINE MXSUB( N,M, A,B,C )
C
C        MATRIX SUBTRACT
C
C     INPUT:
C              N,M       I*4   MATRIX SIZE
C              A         R*8   OF SIZE NxM
C              B         R*8   OF SIZE NxM
C     OUTPUT
C              C         R*8   C = A - B   ,    SIZE NxM
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION   A(*),B(*), C(*)
C
C
      NELM  =  N*M
C
      DO   100 I=1, NELM
C
        C(I) = A(I) - B(I)
C
 100  CONTINUE
C
      RETURN
      END
