      FUNCTION MXIV33(AMX,AIV,DET)
C
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION AMX(3,3),AIV(3,3) 
C 
C 
C     FUNCTION MXIV33 TAKES A THREE BY THREE MATRIX AND COMPUTES THE
C INVERSE MATRIX.  AMX I THE INPUT MATRIX.  AIV IS THE OUTPUT MATRIX. 
C DET IS THE DETERMINATE OF THE INPUT MATRIX.  THE FUNCTIONAL VALUE MXIV
C FLAGS A GOOD OR BAD OUTPUT MATRIX.  IF MXIV33=0, THE RESULTING INVERSE
C VALID.  IF MXIV33=1, THE INVERSE IS INVALID (DET=0).  IN THE LATER CAS
C AIV WILL CONTAIN ONLY THE COFACTOR MATRIX; NOT THE INVERSE MATRIX.
C 
C      WRITTEN: JANUARY 8, 1979 : DRB.
C
C      LAST ALTERED: JANUARY 22, 1979 : DRB.
C                   FEB. 1, 1979 : DRB
C
C                    8-11-89  MOVED TO PC  JRC
C 
C   -------------------------------------------------------------
C
C      COMPUTING THE COFACTOR AND STORING IN AIV. 
C 
      AIV(1,1)= + (AMX(2,2)*AMX(3,3)-AMX(2,3)*AMX(3,2)) 
      AIV(2,1)= - (AMX(2,1)*AMX(3,3)-AMX(2,3)*AMX(3,1)) 
      AIV(3,1)= + (AMX(2,1)*AMX(3,2)-AMX(2,2)*AMX(3,1)) 
C 
      AIV(1,2)= - (AMX(1,2)*AMX(3,3)-AMX(1,3)*AMX(3,2)) 
      AIV(2,2)= + (AMX(1,1)*AMX(3,3)-AMX(1,3)*AMX(3,1)) 
      AIV(3,2)= - (AMX(1,1)*AMX(3,2)-AMX(1,2)*AMX(3,1)) 
C 
      AIV(1,3)= + (AMX(1,2)*AMX(2,3)-AMX(1,3)*AMX(2,2)) 
      AIV(2,3)= - (AMX(1,1)*AMX(2,3)-AMX(1,3)*AMX(2,1)) 
      AIV(3,3)= + (AMX(1,1)*AMX(2,2)-AMX(1,2)*AMX(2,1)) 
C 
C     COMPUTE THE DETERMINATE.
C 
      D=0.0 
      J=1 
      DO 150 I=1,3
      D=D+AMX(J,I)*AIV(I,J) 
  150 CONTINUE
C
      DET=D 
C 
C     CHECK FOR ZERO DETERMINATE;  AND COMPUTATION OF THE INVERSE, OR 
C     INDICATION OF UNDEFINED INVERSE.
C 
      IF(ABS(D).LT.1.0D-100) GO TO 500 
C
      MXIV33=0
C
      DO 300 I=1,3
      DO 200 J=1,3
      AIV(I,J)=AIV(I,J)/D 
  200 CONTINUE
  300 CONTINUE
      GO TO 900 
C
  500 CONTINUE
C
      MXIV33=1
C
  900 CONTINUE
      RETURN
      END 
