$TITLE:'MXIVRT'
         SUBROUTINE MXIVRT ( N, A, D , IERR)
C
C
C        ***************************************************************
C        GAUSS-JORDAN PROCEDURE FOR INVERTING MATRICES/SOLVING EQUATIONS
C        ***************************************************************
C
C          N = DIMENSION OF MATRIX, IN RANGE 1 TO 20
C          A = MATRIX, WILL BE INVERTED IN PLACE
C          D = DETERMINATE
C          IERR   0   OKAY
C                 1   N OUT OF RANGE
C                 2   INVERSION FAILURE
C
$INCLUDE:'WRDSIZ.INC'
C
         DIMENSION A(1)
         DIMENSION IPIVOT(20), INDEX(20,2)
         INTEGER*2        I, J, K, JK, JL, KL, MAXA
         INTEGER*2        IPIVOT, INDEX, IROW, ICOLUM, ICOL
         INTEGER*2        L, IL, I1, KCOL, LCOL
C        ------------------------
C
         D  = 0.0D0
C
         IERR = 0
         IF ( N.GT.0  .AND. N .LE. 20 ) GOTO 100
         IERR = 1
         RETURN
C
 10      CONTINUE
         IERR = 2
         RETURN
C
C        INITIALIZATION
C
100      CONTINUE
         MAXA = N * N
C
         DO 110 J=1,N
         IPIVOT(J) = 0
110      CONTINUE
C
C       REAL DETERMINATE INITIALIZATION
C
        D = 1.0D0
C      
C
         DO 600 I=1,N
C
C        SEARCH FOR THE NEXT PIVOT ELEMENT
C
         PIVOT = 0.D0
         DO 210 J=1,N
         IF (IPIVOT(J).EQ.1) GO TO 210
         JK = J
C
         DO 190 K=1,N
         IF (IPIVOT(K).EQ.1) GO TO 180
         IF (DABS(PIVOT).GE.DABS(A(JK))) GO TO 180
         IROW = J
         ICOLUM = K
         PIVOT = A(JK)
180      CONTINUE
         JK = JK + N
190      CONTINUE
C
210      CONTINUE
C
         D = D*PIVOT
         IF (PIVOT) 300,10,300
C
C        INTERCHANGE ROWS TO PUT PIVVOT ELEMENT ON DIAGONAL
C
300      CONTINUE
C
         IPIVOT(ICOLUM) = 1
         ICOL = (ICOLUM-1)*N 
         INDEX(I,1) = ICOL
         INDEX(I,2) = ICOL
         IF (IROW.EQ.ICOLUM) GO TO 350
         D = -D
         INDEX(I,1) = (IROW-1)*N
C
         JL = IROW
         KL = ICOLUM
C
         DO 340 L=1,N
         SWAP = A(JL)
         A(JL) = A(KL)
         A(KL) = SWAP
         JL = JL + N
         KL = KL + N
340      CONTINUE
C
C        DIVIDE THE PIVOT ROW BY THE PIVOT ELEMENT
C
350      CONTINUE
         A(ICOL+ICOLUM) = 1.0D0
C
         DO 360 IL=ICOLUM,MAXA,N
         A(IL) = A(IL)/PIVOT
360      CONTINUE
C
C        REDUCE THE NON-PIVOT ROWS
C
400     CONTINUE 
C
         DO 500 J=1,N
         IF (J.EQ.ICOLUM) GO TO 500
         T = A(ICOL+J)
         A(ICOL+J) = 0.D0
         IL = ICOLUM
         JL = J
C
         DO 450 L=1,N
         A(JL) = A(JL) - A(IL) *T
         IL = IL + N
         JL = JL + N
C
450      CONTINUE
C
 500     CONTINUE
 600     CONTINUE
C
C        INTERCHANGE THE COLUMNS
C
         I1 = N
         DO 720 I=1,N
         KCOL = INDEX(I1,1)
         LCOL = INDEX(I1,2)
         IF (KCOL.EQ.LCOL) GO TO 710
C
         DO 700 J=1,N
         JK = J+KCOL
         JL = J+LCOL
         SWAP = A(JK)
         A(JK) = A(JL)
         A(JL) = SWAP
700      CONTINUE
C
710      CONTINUE
C
         I1 = I1 -1
720      CONTINUE
C
         RETURN
         END
