$TITLE:'MATRIX NORMS'
$SUBTITLE:'FROBENIUS NORM'
       SUBROUTINE MXNRMF ( N, A, ANORM )
C
C      NORM ( MEASURE OF LENGTH ) OF SQUARE MATRIX
C      ARE SEVERAL NORMS THAT CAN BE DEFINED
C      IF JUST USING MATRIX VALUES--CAN CHOOSE ONE
C      IF ALSO COMBINING WITH VECTOR NORMS SHOULD
C      GET COORSPONDING NORM WITH VECTOR NORM USE
C
C      SEE ATKINSON, INTO TO NUMERICAL ANAYLYSIS CHAPTER 7
C      ESPPG 412 +
C
C      FROBENIUS NORM -- SEPERATE FROM GENERAL CLASS
C            IS RMS OF ALL ELEMENTS
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(N,N)
C
C
      SUM = 0.0D0
C
      DO 200 I=1,N
      DO 100 J=1,N
C
      V   =  A ( I,J)
      SUM =  SUM + V * V
C
100   CONTINUE
200   CONTINUE
C
      ANORM = DSQRT ( SUM )
C
      RETURN
      END
$PAGE
$SUBTITLE:'NORM1'
       SUBROUTINE MXNRM1 ( N, A, ANORM )
C
C      NORM ( MEASURE OF LENGTH ) OF SQUARE MATRIX
C      ARE SEVERAL NORMS THAT CAN BE DEFINED
C      IF JUST USING MATRIX VALUES--CAN CHOOSE ONE
C      IF ALSO COMBINING WITH VECTOR NORMS SHOULD
C      GET COORSPONDING NORM WITH VECTOR NORM USE
C
C      SEE ATKINSON, INTO TO NUMERICAL ANAYLYSIS CHAPTER 7
C      ESPPG 412 +
C
C      NUMBERED NORMS CORRESPOND TO VECTOR NORMS OF FORM
C
C        N =  ( SUM( ABS(X)**P ) **(1/P)
C
C      IE FOR VECTOR TAKE P TH POWER OF ABS VALUE OF ELEMENTS
C      AND THEN THE P TH ROOT OF SUM
C
C      THE CORRESPONDING -- IE WORK WITH COMPATIBLY SO THAT
C         NORM ( A * X )  .LE.  NORM ( A) * NORM(X)
C         A=ARRAY, X = VECTOR
C      ARE NOT ALWAYS STRAIGHT FORWARD
C        
C       NORM1    VECTOR  = SUM OF ABS OF COMPONENTS
C                MATRIX  = MAX OF VECTOR NORM1 OF COLUMNS IN MATRIX
C   
C       NORM2    VECTOR = NORMAL LENGTH USED = SQRT( SUM (X(I)**2)))
C                MATRIX = SQRT ( SPECTRAL RADIUS ( At * A ))
C                         SPECTRAL RADIUS = MAXIMUM EIGENVALUE
C                         At * A  = ADJOINT ( A) TIME A
C       NORMI    VECTOR =  P = INFINITY = MAX OF ABS OF COMPONENT
C                MATRIX =  MAX OF NORMI OF COLUMN VECTORS
C
C        -- NOTE CAN JUST AS WELL USE ROWS IN ABOVE MATRIX ITEMS
C           AS ALL REQUIRED INEQUALITIES FOR NORMS IMPLY THAT
C           NORM ( A )  = NORM( A TRANSPOSE )
C          ( IF NOT NUMERICALLY, THEN FUNCTIONALLY )
C
C      ======================================================
C      NORM 1
C      ======================================================
C
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(N,N)
C
C      COLUMN NORM = NORM1
C
      SUMMX = 0.0D0
C
      DO 200 J=1,N
C
      SUM   = 0.0D0      
C
      DO 100 I=1,N
C
      V   =  A ( I,J)
      SUM =  SUM + DABS(V)
C
100   CONTINUE
C
      IF ( SUM.GT.SUMMX ) SUMMX = SUM
C
200   CONTINUE
C
      ANORM = SUMMX
C
      RETURN
      END
