$TITLE:'3-D AND 4-D MATRIX ROUTINES'
$SUBTITLE:'MATRIX MULTIPLY 4 X 4'
      SUBROUTINE MXM44 ( A, B, C )
C
C     4 X 4 MATRIX MULTIPLY
C
C     C = A X B
C
C     STORAGE SO C CAN BE A OR B
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(4,4),B(4,4),C(4,4)
      DIMENSION P(4,4)
C
C
      INTEGER*2  I,J,M
C
      DO 400 I = 1, 4
      DO 300 J = 1, 4
C
      SUM = 0.0D0
      DO 200 M = 1, 4
C
      SUM = SUM + A(I,M) * B(M,J)
C
200   CONTINUE
C
      P(I,J) = SUM
C
300   CONTINUE
400   CONTINUE
C
      DO 500 I =1,4
      DO 490 J =1,4
C
      C(I,J) = P(I,J)
C
490   CONTINUE
500   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX MULT 3 X 3'
      SUBROUTINE MXM33 ( A, B, C )
C
C     3 X 3 MATRIX MULTIPLY
C
C     C = A X B
C
C     STORAGE SO C CAN BE A OR B
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(3,3),B(3,3),C(3,3)
      DIMENSION P(3,3)
C
C
      INTEGER*2  I,J,M
C
      DO 400 I = 1, 3
      DO 300 J = 1, 3
C
      SUM = 0.0D0
      DO 200 M = 1, 3
C
      SUM = SUM + A(I,M) * B(M,J)
C
200   CONTINUE
C
      P(I,J) = SUM
C
300   CONTINUE
400   CONTINUE
C
      DO 500 I =1,3
      DO 490 J =1,3
C
      C(I,J) = P(I,J)
C
490   CONTINUE
500   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX MULT 2 X 2'
      SUBROUTINE MXM22 ( A, B, C )
C
C     2 X 2 MATRIX MULTIPLY
C
C     C = A X B
C
C     STORAGE SO C CAN BE A OR B
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(2,2),B(2,2),C(2,2)
      DIMENSION P(2,2)
C
C
      INTEGER*2  I,J,M
C
      DO 400 I = 1, 2
      DO 300 J = 1, 2
C
      SUM = 0.0D0
      DO 200 M = 1, 2
C
      SUM = SUM + A(I,M) * B(M,J)
C
200   CONTINUE
C
      P(I,J) = SUM
C
300   CONTINUE
400   CONTINUE
C
      DO 500 I =1,2
      DO 490 J =1,2
C
      C(I,J) = P(I,J)
C
490   CONTINUE
500   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX MULTIPLY TRANSPOSE 4 X 4'
      SUBROUTINE MXMT44 ( A, B, C )
C
C     4 X 4 MATRIX MULTIPLY WITH SECOND ITEM TRANSPOSED
C
C     C = A X B(TRANSPOSED)
C
C     STORAGE SO C CAN BE A OR B
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(4,4),B(4,4),C(4,4)
      DIMENSION P(4,4)
C
C
      INTEGER*2  I,J,M
C
      DO 400 I = 1, 4
      DO 300 J = 1, 4
C
      SUM = 0.0D0
      DO 200 M = 1, 4
C
      SUM = SUM + A(I,M) * B(J,M)
C
200   CONTINUE
C
      P(I,J) = SUM
C
300   CONTINUE
400   CONTINUE
C
      DO 500 I =1,4
      DO 490 J =1,4
C
      C(I,J) = P(I,J)
C
490   CONTINUE
500   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX MULT TRANSPOSED 3 X 3'
      SUBROUTINE MXMT33 ( A, B, C )
C
C     3 X 3 MATRIX MULTIPLY TRANSPOSED SECOND MTRX
C
C     C = A X B(TRANSPOSED)
C
C     STORAGE SO C CAN BE A OR B
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(3,3),B(3,3),C(3,3)
      DIMENSION P(3,3)
C
C
      INTEGER*2  I,J,M
C
      DO 400 I = 1, 3
      DO 300 J = 1, 3
C
      SUM = 0.0D0
      DO 200 M = 1, 3
C
      SUM = SUM + A(I,M) * B(J,M)
C
200   CONTINUE
C
      P(I,J) = SUM
C
300   CONTINUE
400   CONTINUE
C
      DO 500 I =1,3
      DO 490 J =1,3
C
      C(I,J) = P(I,J)
C
490   CONTINUE
500   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX MULT TRANSPOSED 2 X 2'
      SUBROUTINE MXMT22 ( A, B, C )
C
C     2 X 2 MATRIX MULTIPLY TRANSPOSED SECOND MTRX
C
C     C = A X B(TRANSPOSED)
C
C     STORAGE SO C CAN BE A OR B
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(2,2),B(2,2),C(2,2)
      DIMENSION P(2,2)
C
C
      INTEGER*2  I,J,M
C
      DO 400 I = 1, 2
      DO 300 J = 1, 2
C
      SUM = 0.0D0
      DO 200 M = 1, 2
C
      SUM = SUM + A(I,M) * B(J,M)
C
200   CONTINUE
C
      P(I,J) = SUM
C
300   CONTINUE
400   CONTINUE
C
      DO 500 I =1,2
      DO 490 J =1,2
C
      C(I,J) = P(I,J)
C
490   CONTINUE
500   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX MULTIPLY TIMES VECTOR [4] '
      SUBROUTINE MXV44 ( A, B, C )
C
C    MULTIPLY MATRIX TIMES VECTOR IN 4-DIM
C
C     C = A X B
C
C     STORAGE SO C CAN BE A OR B
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(4,4),B(4),C(4)
      DIMENSION P(4)
C
C
      INTEGER*2  I,M
C
      DO 400 I = 1, 4
C
      SUM = 0.0D0
      DO 200 M = 1, 4
C
      SUM = SUM + A(I,M) * B(M)
C
200   CONTINUE
C
      P(I) = SUM
C
400   CONTINUE
C
      DO 500 I =1,4
C
      C(I) = P(I)
C
500   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX MULTIPLY TIMES VECTOR [3] '
      SUBROUTINE MXV33 ( A, B, C )
C
C    MULTIPLY MATRIX TIMES VECTOR IN 3-DIM
C
C     C = A X B
C
C     STORAGE SO C CAN BE A OR B
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(3,3),B(3),C(3)
      DIMENSION P(3)
C
C
      INTEGER*2  I,M
C
      DO 400 I = 1, 3
C
      SUM = 0.0D0
      DO 200 M = 1, 3
C
      SUM = SUM + A(I,M) * B(M)
C
200   CONTINUE
C
      P(I) = SUM
C
300   CONTINUE
400   CONTINUE
C
      DO 500 I =1,3
C
      C(I) = P(I)
C
500   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
$PAGE
$SUBTITLE:'MATRIX MULTIPLY TIMES VECTOR [2] '
      SUBROUTINE MXV22 ( A, B, C )
C
C    MULTIPLY MATRIX TIMES VECTOR IN 2-DIM
C
C     C = A X B
C
C     STORAGE SO C CAN BE A OR B
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION A(2,2),B(2),C(2)
      DIMENSION P(2)
C
C
      INTEGER*2  I,M
C
      DO 400 I = 1, 2
C
      SUM = 0.0D0
      DO 200 M = 1, 2
C
      SUM = SUM + A(I,M) * B(M)
C
200   CONTINUE
C
      P(I) = SUM
C
300   CONTINUE
400   CONTINUE
C
      DO 500 I =1,2
C
      C(I) = P(I)
C
500   CONTINUE
C
900   CONTINUE
C
      RETURN
      END
