      REAL*4 FUNCTION QINTB4 ( X, F )
C
C         Q-INTERPOLATION OF EVENLY SPACED POINTS
C              Newton Gregory Forward Polynomial
C              (Based on NGS routine)
C
C          ****** REAL * 4     FUNCTIONS   *******
C
C         X      = independent variable to use
C         F(3)   = array of data to use
C
C
C  ***************************************************************
C
C    ***    X  is biased to that X of F(1)  is 0  Zero   ***
C           Biased to BEGINNING of table section
C
C         MEANS       F(1)  =  Function at 0.0
C                     F(2)  =  Function at 1.0
C                     F(3)  =  Function at 2.0
C
C                   See that X value is scaled ! 
C  ***************************************************************
C
C
C    INPUT:
C              X         R*4       INDEPENDENT VARIABLE BIASED
C                                  BY VALUE FOR 1ST ELEMENT
C              F(3)      R*4       THREE POINT ARRAY OF FUNCTIONAL
C                                  DATA
C
C    OUTPUT
C              FUNDTION VALUE   R*4    VALUE OF QUADRATIC THAT FITS
C                                      THREE POINTS AT X
C
C    MODHIST
C         1-10-97        JRC CODED
C
C====$INCLUDE:'WRDSIZ.INC'
C
      REAL*4       X,F
      REAL*4       XI,XM1,F1,F2,DF0,DF1,D2F,VAL
C
      DIMENSION     F(3)
C
C    ------------------------------------------------------
C
C
      F1      =   F(1)
      F2      =   F(2)
C
      DF0     =   F2   - F1
      DF1     =   F(3) - F2
C
      D2F     =   DF1  - DF0
C
      XI      =   X
      XM1     =   XI - 1.0
C
      VAL     =   F1 + XI*DF0  + 0.5*XI*XM1*D2F
C
      QINTB4  =   VAL
C
      RETURN
      END
$PAGE
      REAL*4 FUNCTION QINTC4 ( X, F )
C
C         Q-INTERPOLATION OF EVENLY SPACED POINTS
C              Newton Gregory Forward Polynomial
C              (Based on NGS routine)
C
C          ****** REAL * 4     FUNCTIONS   *******
C
C
C         X      = independent variable to use
C         F(3)   = array of data to use
C
C
C  ***************************************************************
C
C    ***    X  is biased to that X of F(1)  is   -1.0    ***
C           Biased to CENTER of table section
C
C         MEANS       F(1)  =  Function at -1.0
C                     F(2)  =  Function at  0.0
C                     F(3)  =  Function at  1.0
C
C                   See that X value is scaled ! 
C  ***************************************************************
C
C
C    INPUT:
C              X         R*8       INDEPENDENT VARIABLE BIASED
C                                  BY VALUE FOR 2ND ELEMENT
C              F(3)      R*8       THREE POINT ARRAY OF FUNCTIONAL
C                                  DATA
C
C    OUTPUT
C              FUNDTION VALUE   R*8    VALUE OF QUADRATIC THAT FITS
C                                      THREE POINTS AT X
C
C    MODHIST
C         1-10-97        JRC CODED
C
C====$INCLUDE:'WRDSIZ.INC'
C
C
      REAL*4       X,F
      REAL*4       XI,XM1,F1,F2,DF0,DF1,D2F,VAL
C
      DIMENSION     F(3)
C
C    ------------------------------------------------------
C
C
      F1      =   F(1)
      F2      =   F(2)
C
      DF0     =   F2   - F1
      DF1     =   F(3) - F2
C
      D2F     =   DF1  - DF0
C
C           CONSTRUCT INDEP. VAR. AS IF BIASED 1ST ITEM
C
      XM1     =   X
      XI      =   XM1+1.0
C
      VAL     =   F1 + XI*DF0  + 0.5*XI*XM1*D2F
C
      QINTC4  =   VAL
C
      RETURN
      END
