      PROGRAM RESQRD
C
C       RESIDUALS FROM
C       LEAST SQ QUARATIC LINE FIT 
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION  P(3),R(3)
      DIMENSION  SVEC(10)
C
      CHARACTER * 30   FNIN,FNOUT
      CHARACTER * 30   FNLOG
C
$INCLUDE:'MLS.INC'
C
C     -------------------------------------------------------------
C
C
      VER = 1.1
      WRITE (*,2000 ) VER
2000  FORMAT (//4X,'REMOVE QUADRATIC LINE FROM DATA Ver',F5.2/ )
C
      LUNLOG = 4
      FNLOG  = 'FITLOG.TXT'
C
C
100   CONTINUE
C
      WRITE (*,2001)
2001  FORMAT(4X,'ENTER INPUT  FILE NAME: '\)
      READ ( *, 1001 ) FNIN
1001  FORMAT ( A )
C
      LUNIN = 1
      OPEN ( LUNIN, FILE=FNIN, STATUS='OLD', IOSTAT=IOCK )
      IF ( IOCK.NE. 0 ) THEN 
           WRITE (*,2101 ) IOCK
2201       FORMAT ( //4X,'OPEN ERROR ',I10,/)
           GOTO 100
      ENDIF
C
110   CONTINUE
C
C
120   CONTINUE
C
      WRITE (*,2002)
2002  FORMAT(4X,'ENTER OUTPUT FILE NAME: '\)
      READ ( *, 1001 ) FNOUT
C
      LUNW  = 2
      OPEN ( LUNW , FILE=FNOUT, STATUS='UNKNOWN', IOSTAT=IOCK )
      IF ( IOCK.NE. 0 ) THEN 
           WRITE (*,2101 ) IOCK
           GOTO 120
      ENDIF
C
C
      WRITE (*,2003 )
2003  FORMAT ( /4X,'X FIELD NUMBER ( 0=> USE POINT) : '\ )
      READ (*,* ) NFLDX
      NFX  = NFLDX
      IF ( NFX.LE.0 ) NFX = 1
C
      WRITE (*,2004)
2004  FORMAT (  4X,'Y FIELD NUMBER                  : ' \)
      READ (*,*) NFLDY
C
C
C
130   CONTINUE
C
      WRITE (*,2006)
2006  FORMAT ( /4X,'NUMBER OF RECORDS TO SKIP, N-PROCESS : '\)
      READ (*,*) NSKIP,NDO
C
      CLOSE ( LUNLOG )
      OPEN ( LUNLOG,FILE=FNLOG, STATUS='OLD',ACCESS='APPEND',
     $       IOSTAT = IOCK)
      IF ( IOCK.NE.0 ) THEN
        CLOSE ( LUNLOG )
        OPEN ( LUNLOG,FILE=FNLOG,STATUS='NEW',IOSTAT=IOCK)
        IF ( IOCK.NE.0 ) THEN
           LUNLOG = -4
           WRITE (*,2091)
2091       FORMAT (/4X,'    Error Opening Log File '/)
        ENDIF
      ENDIF
C
C
      IF ( LUNLOG.GT.0 ) THEN
        WRITE (LUNLOG,2200) VER, FNIN, FNOUT,NFLDX,NFLDY,NSKIP,NDO
2200    FORMAT (//4X,'QUADRATIC FIT RESIDUALS (RESQRD) Ver ',F5.2/
     $           /4X,'File Name Input   : ',A
     $           /4X,'File Name Output  : ',A,/
     $           /4X,'X,Y Field Numbers : ',2I10
     $           /4X,'Nskip,Ndo         : ',2I10
     $           //)
      ENDIF
C
C
C
C            -------------------------------
C
      IPASS  =  1
C
      IXBIAS =  0
C
      ATOT   =  0.0
      BTOT   =  0.0
      CTOT   =  0.0
C 
C
C
C             RE-CYLE POINT 
C
180   CONTINUE
C
       NPTS  = 0
       IRSUM = 0  
C
       CALL  STATL ( DUM, DUM, SVEC )
C
       NPARMS  = 3
       CALL IOMLS ( NPARMS, IER )
C
C
      IF ( NSKIP.LE.0) GOTO 150
C
      DO 140 ISK = 1, NSKIP
      READ (LUNIN, 1009,END=800,ERR=140) L
1009  FORMAT ( A )
140   CONTINUE
150   CONTINUE
C
C     -----------------------------------------------------------
C
200   CONTINUE
C
C          INPUT DATA
C
      NPTS = NPTS + 1
      IF ( NPTS.GT.NDO ) GOTO 800
C
      CALL  RDFFX ( LUNIN, NFX, RDX, ISTAT )
C
      IF ( ISTAT.EQ.-1 ) GOTO 800
C      
      IF ( NFLDX.LE.0 ) RDX  = NPTS - 1
      IF ( ISTAT.NE.0 .AND. NFLDX.GT.0 ) GOTO 700 
C
      CALL RRDFFX (         NFLDY, RDY, ISTAT )
      IF ( ISTAT.NE.0) GOTO 700
C
      RDW  = 1.0D0
C
      W = 1.0D0 / (RDW * RDW)
C
C       PARTIALS OF Y = A*X**2 + B*X + C  :   ( X**2, X,  1 )
C
      IF ( IXBIAS.EQ.0 ) THEN
          XBIAS  = RDX
          IXBIAS = 1
      ENDIF
C
      XUSE   = RDX - XBIAS
      YUSE   = RDY
      IF ( IPASS .EQ.2 ) THEN
           YMODEL  =  A*XUSE*XUSE + B*XUSE + C 
           YUSE    =  RDY - YMODEL
           WRITE (LUNW,2021) RDX, YUSE
2021       FORMAT ( F20.3,F20.6 )
      ENDIF
C
      P(1)  = XUSE*XUSE
      P(2)  = XUSE
      P(3)  = 1.0D0
C
      CALL OMLS ( YUSE, P )
C
      CALL  STATXY ( XUSE, YUSE, SVEC )
C
      GOTO 200
C
C    ------------------------------------------------------------
C
C           ERROR CONDITION
C
700   CONTINUE
C
      IF ( ISTAT.EQ.-1 ) GOTO 800
C
      WRITE (*,2110 ) NPTS + 1
2110  FORMAT ( //4X,'ERROR ON READ ',I5/)
C
      GOTO 200
C
C           END OF FILE /  DATA END
C
800   CONTINUE
C
C   
      CALL ROMLS ( R, IER )
C
      NPTS = NPTS - 1
      WRITE (*,2100 ) IPASS,FNIN,NPTS
      IF (LUNLOG.GT.0) WRITE (LUNLOG,2100 ) IPASS,FNIN,NPTS
2100  FORMAT (//4X,' Pass  ',I5,3X,'File :  ',A/
     $          4X,' Mean Least Squares Fit for ',I6,' Pts'/)
C
      ATOT =  ATOT + R(1)
      BTOT =  BTOT + R(2)
      CTOT =  CTOT + R(3)
C
      AUSE = ATOT
      BUSE = BTOT - 2.0*ATOT*XBIAS
      CUSE = CTOT - BTOT*XBIAS + ATOT*XBIAS*XBIAS
C
      WRITE (*,2101) AUSE,BUSE,CUSE
2101  FORMAT ( 4X,'     Y=A*X**2 + B*X + C '/
     $         4X,'     A= ',D16.8,3X,'B= ',D16.8,3X,'C=  ',D16.8)
C
      A    =   ATOT
      B    =   BTOT
      C    =   CTOT
C
      VARA   =  COV(1)
      VARB   =  COV(5)
      VARC   =  COV(9)
      SIGA   =  SQRT ( VARA )
      SIGB   =  SQRT ( VARB )
      SIGC   =  SQRT ( VARC )
C
      VARAU  =   VARA
      VARBU  =   VARB + (2.0D0*SIGA*XBIAS)**2
      VARCU  =   VARC + (SIGB*XBIAS)**2  +  (SIGA*XBIAS*XBIAS)**2
      SIGAU  =   SQRT(VARAU)
      SIGBU  =   SQRT(VARBU)
      SIGCU  =   SQRT(VARCU)
C
C
      WRITE (*,2103) SIGAU,SIGBU,SIGCU
2103  FORMAT(4X,' SIG-A= ',D12.6,3X,'SIG-B=   ',D12.6,
     $       3X,'SIG-C=   ',D12.6/)
C
      IF ( LUNLOG.GT.0 ) THEN
         XBZ = 0.0D0
         WRITE (LUNLOG,2121) XBZ,
     $                      AUSE,SIGAU,BUSE,SIGBU,CUSE,SIGCU
         WRITE (LUNLOG,2121) XBIAS,
     $                      ATOT,SIGA,BTOT,SIGB,CTOT,SIGC
2121  FORMAT (/4X,'     Y=A*X**2 + B*X + C '/
     $         4X,'X_BIAS= ',F20.6/
     $         4X,'     A= ',D20.14,4X,'SIG_A=',1X,D12.6/
     $         4X,'     B= ',D20.14,4X,'SIG_B=',1X,D12.6/
     $         4X,'     C= ',D20.14,4X,'SIG_C=',1X,D12.6/)
      ENDIF
C
      CALL STATR ( DUM, DUM, SVEC )
      SIGRES   =  SVEC ( 5 )
C
      WRITE (*,2104)  SIGRES
      IF (LUNLOG.GT.0 ) WRITE (LUNLOG,2104)  SIGRES
2104  FORMAT (4X,'    CURRENT SIGMA- Y : ',D14.6 / )
C
      IF ( IPASS.EQ.1 ) THEN
          IPASS = 2
          REWIND ( LUNIN )
          GOTO 180
      ENDIF
C
900   CONTINUE
C
      CLOSE ( LUNIN )
C
      END
