      PROGRAM RLSTATE
C
C       STATICS OF FILE OF REALS -- WITH EDITS
C
C     MOD HIST:
C       2-25-91  FREE FILE INPUT
C       9-7-91   SIGMA EDITING
C       2-28-99  MORE DIGITS IN COUNTS
C       3-4-99   LOG FILE
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION  STATV ( 10 )
C
      CHARACTER * 30   FNIN
      CHARACTER * 1    L
C
C
      CHARACTER*30     FNLOG
      CHARACTER*1      FF
C
C     -------------------------------------------------------------
C
C
      VER = 2.2
      WRITE (*,2000 ) VER
2000  FORMAT (//4X,'STATISTICS - REAL VALUES / SIGMA EDITING',
     $        ' Ver ',F7.2/
     $          4X,' James R. Clynch Naval Postgraduate School'/ )
C      OPEN LOG FILE
C
       FF    =  CHAR(12)
       FNLOG = 'RLSTATE.LOG'
       LUNL = 4
       ILOG = 1
       CLOSE ( LUNL )
       OPEN ( LUNL,FILE=FNLOG,STATUS='OLD',ACCESS='APPEND',
     $        IOSTAT= IOCK )
       IF ( IOCK.NE. 0 ) THEN
           CLOSE ( LUNL )
           OPEN ( LUNL,FILE=FNLOG,STATUS='NEW',IOSTAT= IOCK )
       ELSE
           WRITE (LUNL,2099) FF
2099       FORMAT ( A )
       ENDIF
       IF ( IOCK.NE.0 ) THEN
           WRITE (*,2091) IOCK
2091        FORMAT (//10X,'--- OPEN ERROR ON LOG FILE -- '//)
            ILOG  = 0
            CLOSE (LUNL )
       ENDIF
C
      IF ( ILOG.NE.0 ) WRITE (LUNL,2000) VER
C
C
100   CONTINUE
C
      WRITE (*,2001)
2001  FORMAT(4X,'ENTER INPUT  FILE NAME: '\)
      READ ( *, 1001 ) FNIN
1001  FORMAT ( A )
C
      LUNIN = 1
      OPEN ( LUNIN, FILE=FNIN, STATUS='OLD', IOSTAT=IOCK )
      IF ( IOCK.NE. 0 ) THEN 
           WRITE (*,2101 ) IOCK
2101       FORMAT ( //4X,'OPEN ERROR ',I10,/)
           GOTO 100
      ENDIF
C
110   CONTINUE
C
C
120   CONTINUE
C
      WRITE (*,2003 )
2003  FORMAT ( /4X,'ENTER FIELD NUMBER OF DATA: '\ )
      READ (*,* ) IFLDN
      IF ( IFLDN.LE.0 ) GOTO 120
C
C
130   CONTINUE
C
       WRITE (*,2006 )
2006   FORMAT ( 4X,'SIGMA MULTIPLIER FOR EDITING : '\ )
       READ (*,*) SIGM
C
      WRITE (*,2004)
2004  FORMAT ( /4X,'NUMBER OF RECORDS TO SKIP: '\)
      READ (*,*) NSKIP
C
C
      IF ( ILOG.NE.0 ) THEN
         WRITE (LUNL,2020) FNIN, IFLDN,SIGM, NSKIP
2020     FORMAT ('*'/'*'/
     $            '*',10X,'Input File: ',A/
     $            '*',10X,'Field     : ',I8,
     $                3X,'with Sigma Multiplier',F10.2/
     $            '*',10X,'Skipping  : ',I8,'  Headers'/'*')
      ENDIF
C
C
      ITER   = 0
      NULST  = 0
      NPTS   = 0
      NEDIT  = 0
      SIGLST = 0.0D0
      AVGLST = 0.0D0
C
C
C ================================================================
C
200   CONTINUE
C
      ITER  = ITER + 1
      IF  ( ITER.GT.4 ) GOTO 900
C
      NUSED  = NPTS - NEDIT
      IF ( ITER.GT.2 ) THEN
         NDIF = NUSED - NULST
         IF ( NDIF.EQ.0 ) GOTO 900
      ENDIF
C
      NULST = NUSED
      NPTS  = 0
      NEDIT = 0
C
      STRIP =  SIGM * SIGLST
C      
      CALL STATL ( DUM,DUM, STATV )
C
C
      LUNIN = 1
      CLOSE (LUNIN)
      OPEN ( LUNIN, FILE=FNIN, STATUS='OLD', IOSTAT=IOCK )
C
      IF ( NSKIP.LE.0) GOTO 220
C
      DO 210 ISK = 1, NSKIP
      READ (LUNIN, 1009,END=800,ERR=700) L
1009  FORMAT ( A )
210   CONTINUE
C
220   CONTINUE
C
C     -----------------------------------------------------------
C
300   CONTINUE
C
      CALL RDFFX  ( LUNIN, IFLDN, Y, ISTAT )
      IF ( ISTAT.EQ.-1 ) GOTO 800
      IF ( ISTAT.NE.0  ) GOTO 700
C
      NPTS  = NPTS + 1
      X     = NPTS
C
      RES  = Y - AVGLST 
C
      IF ( ITER.GT.1 ) THEN
         IF ( ABS(RES) .GT.  STRIP ) THEN
           NEDIT = NEDIT + 1
           GOTO 300
         ENDIF
      ENDIF
C
      CALL STATXY (  X, RES, STATV )
C
      GOTO 300
C
C    ------------------------------------------------------------
C
C           ERROR CONDITION
C
700   CONTINUE
C
      WRITE (*,2110 ) NPTS + 1
      IF ( ILOG.NE.0 ) WRITE (LUNL,2110 ) NPTS + 1
2110  FORMAT ( /4X,'ERROR ON READ ',I10/)
C
      GOTO 300
C
C           END OF FILE
C
800   CONTINUE
C
C
      CALL STATR ( DUM, DUM, STATV )
C
      AVGX     =  STATV ( 2 )
      AVGOUT   =  STATV ( 3 ) + AVGLST
      SDX      =  STATV ( 4 )
      SDOUT    =  STATV ( 5 )
      CCOEF    =  STATV ( 8 )
      SDYX     =  STATV ( 9 )
C
C
      WRITE (*, 2011 ) ITER,NPTS,NEDIT,STRIP,
     $                 AVGOUT,SDOUT,CCOEF,SDYX
      IF ( ILOG.NE.0 ) THEN
           WRITE (LUNL, 2011 ) ITER,NPTS,NEDIT,STRIP,
     $                         AVGOUT,SDOUT,CCOEF,SDYX
      ENDIF
2011  FORMAT ( /4X,' ITERATION ',I3,I8,' POINTS USED,'I8,' EDITED'
     $               ' AT LIMIT ',F10.3/
     $          4X,6X,'INPUT   AVG ',F18.6,3X,'SD    ',F18.6/
     $          4X,6X,'COR. COEF   ',F18.6,3X,'SDY/X ',F18.6/)
C
       SIGLST  = SDOUT
       AVGLST  = AVGOUT
C
       GOTO 200
C
900   CONTINUE
C
C
      CLOSE ( LUNIN )
      CLOSE (LUNL)
C
      END
