      PROGRAM SMTHW
C
C        SMOOTH DATA VIA WINDOWS
C        1 INPUT, 1 SMOOTH PARAMETER
C
C    MODHIST:
C              JRC   1991 CODED
C              5-31-96  ADDED COMMENTS AT TOP WITH PARAMETERS USED
C
C
C
$INCLUDE:'WRDSIZ.INC'
C
C
      CHARACTER*30   FNIN,FNOUT
C
      CHARACTER*80   LINE
C
      DIMENSION      WP(5), WORK(2048), XYOUT(3,51 )
      COMMON   /WKW1/ WORK
C
      DATA  MAXR / 50 /
C
C ------------------------------------------------------------------
C
100   CONTINUE
C
      VER  = 1.1
      WRITE (*,2000) VER
2000  FORMAT ( /4X,'X,Y,  SMOOTHING:  WINDOWING PROGRAM  VER',F5.2/
     $          4X,'    James R. Clynch Naval Postgraduate School'//)
C
C
120   CONTINUE
C
      WRITE (*, 2001 )
2001  FORMAT (4X,'INPUT  FILE  NAME:            '\)
      READ (*, 1000) FNIN
1000  FORMAT ( A )
C
      LUN1  = 1
      CLOSE ( LUN1 )
      OPEN ( LUN1, FILE=FNIN, STATUS='OLD',IOSTAT=IOCK )
      IF ( IOCK.NE.0 ) THEN
         WRITE (*,2091) IOCK
2091     FORMAT ( /4X,'== OPEN ERROR ',I8,'  =='/)
         GOTO 120
      ENDIF
C
C
160   CONTINUE
C
      WRITE (*, 2003 )
2003  FORMAT (4X,'OUTPUT FILE  NAME:            '\)
      READ (*, 1000) FNOUT
C
      LUN3  = 3
      CLOSE ( LUN3 )
      OPEN ( LUN3, FILE=FNOUT, STATUS='UNKNOWN',IOSTAT=IOCK )
      IF ( IOCK.NE.0 ) THEN
         WRITE (*,2091) IOCK
         GOTO 160
      ENDIF
C
C
      WRITE (*,2011)
2011  FORMAT (/4X,'X, AND Y, FIELD NUMBERS : '\)
      READ (*,* ) NFX1,NFY1
C
180   CONTINUE
C
      WRITE (*,2012 )
2012  FORMAT (/4X,'WINDOW PARAMETERS '/
     $         4X,'WIDTH MUST BE LESS THAN 500 INPUT POINTS'/
     $        /4X,'X-ZERO OUT, DX OUT, FULL WIDTH : '\ )
      READ (*,*) XZ, DXOUT,WIDTH
C
      NR  =  WIDTH/DXOUT + 1
      IF ( NR.GT.MAXR ) THEN
           WRITE (*,2092) MAXR-1
2092       FORMAT (/4X,'--- WIDTH MUST BE LESS THAN ',I5,
     $                 ' TIMES DX-OUT ' )
           GOTO 180
      ENDIF
C
190   CONTINUE
C
      WRITE (*,2014 )
2014  FORMAT ( /4X,'WINDOW TYPE  '/
     $          4X,' 1 = SQUARE         2 = TRIANGLE'/
     $          4X,' 3 = COSINE         4 = HANN ( RAISED COS ) '/
     $          4X,' 5 = HAMMING ( COS ON PEDISTAL ) '/
     $         /4X,' TYPE = '\ )
C
      READ (*,* ) ITYWIN
      IF ( ITYWIN.LT.1 .OR. ITYWIN.GT.5 ) GOTO 190
C
C
      CALL WINDWI ( XZ,DXOUT, ITYWIN, WIDTH, WP,  ISTAT )
      IF ( ISTAT.NE.0 ) THEN
          WRITE (*,2093)
2093      FORMAT (/10X,'--- WINDOW ROUTINES INITIALIZATION ERROR',
     $                 ' ----' /)
          GOTO 180
      ENDIF
C     
      WRITE (*,2015)
2015  FORMAT (/4X,'MINIMUM NUMBER POINTS IN AVG FOR USE : '\ )
      READ (*,*) MINUSE
C
      WRITE (*,2016 )
2016  FORMAT ( /4X,'SCALE FOR X  VARIABLE   : '\ )
      READ (*,* )  XSC
C
      WRITE (*,2017)
2017  FORMAT (  4X,'SCALE FOR Y PARAMETER   : '\ )
      READ (*,* ) YSC
C
      NREC = 0
      NW   = 0
      NEDIT = 0
      XBEG  = 0.0D0
      XEND  = 0.0D0
C
C
      LENLIN  = 80
C
C                             --------------
C
      WRITE (LUN3,2100) VER,FNIN,FNOUT,ITYWIN,WIDTH,DXOUT,XZ,MINUSE,
     $               NFX1,XSC,NFY1,YSC
2100  FORMAT ('*',4X,'X,Y,  SMOOTHING:  WINDOWING PROGRAM  VER',F5.2/
     $        '*',4X,'    James R. Clynch Naval Postgraduate School'/
     $        '*'/'*'/
     $        '*',10X,'Input File:  ',A/
     $        '*',10X,'Output File: ',A / '*'/
     $        '*',10X,'WINDOW Type=  ',I3,/
     $        '*'/
     $        '*',4X,' 1 = SQUARE         2 = TRIANGLE'/
     $        '*',4X,' 3 = COSINE         4 = HANN ( RAISED COS ) '/
     $        '*',4X,' 5 = HAMMING ( COS ON PEDISTAL ) '/
     $        '*'/ 
     $        '*',10X,'Window Width :    ',F10.3/
     $        '*',10X,'Dx-OUT       :    ',F10.3,
     $                 3X,'Aligned with X0= ',F10.3/
     $        '*',10X,'Using Minimum of ',I4,'  Input Points/Output'/
     $        '*'/
     $        '*',4X,'Scaleing of Output'/
     $        '*',10X,'X   (Input field ', I3, ' )',2X,F10.3/
     $        '*',10X,'Y   (Input field ', I3, ' )',2X,F10.3/
     $        '*'/'*')
C
C
C ------------------------------------------------------------
C
      ITO  = 1
C
200   CONTINUE
C
C          NEW READ POINT
C
300   CONTINUE
C
      READ ( LUN1, 1003, END=800,ERR=800 ) LINE
1003  FORMAT ( A )
C
      CALL GETFFX ( LENLIN, LINE, NFY1, Y, IST )
      IF ( IST.NE.0 ) GOTO 300
C
      CALL GETFFX ( LENLIN, LINE, NFX1, X, IST )
      IF ( IST.NE.0 ) GOTO 300
C
      NREC  = NREC + 1
      IF ( NREC.EQ.1 )  XBEG = X
      XEND  = X      
C
C        ------------------------------------------
C
      CALL WINDWS ( X,Y, WP, NOUT, XYOUT, WORK )
      IF ( NOUT.LE.0 ) GOTO 300
C
      DO 400 I = 1, NOUT
C
         XOUT =  XSC * XYOUT ( 1,I)
         YOUT =  YSC * XYOUT ( 2,I)
         NPTU =  XYOUT ( 3,I)
C
         IF ( NPTU.LT. MINUSE ) THEN
             NEDIT  = NEDIT + 1
             GOTO 400
         ENDIF
C
         WRITE (LUN3, 2101) XOUT,YOUT,NPTU
2101     FORMAT ( 2F18.5, I4 )
C
         NW   = NW + 1
C
400   CONTINUE
C
C
      GOTO 300
C
C----------------------------------------------------------------
C
C         END OF FILES
C
800   CONTINUE
C
      DXTOT  =  XEND - XBEG
      NMAX   =  DXTOT/DXOUT
C
      WRITE (*,2031 ) NREC,XBEG,XEND,NW,NEDIT,NMAX
2031  FORMAT (/4X,I8,'  RECORDS BETWEEN  X  OF ',F12.3, '  AND',
     $                F12.3/
     $         4X,I8,'  RECORDS WRITTEN,',I8,' EDITED, OF POSSIBLE',
     $             I8//)
C
C
      GOTO 900
C
900   CONTINUE
C
      CLOSE ( LUN1 )
      CLOSE ( LUN3 )
C
      END
