      PROGRAM  SPHDAT
C
C         OUTPUT THE FULL RANGE OF SPHERICAL HARMONIC L,M
C
$INCLUDE:'WRDSIZ.INC'
C
C
      CHARACTER*30    FNOUT
C
      DATA    PI /    3.14159 26535 898D00 /
      DATA   TPI /    6.28318 53071 796D0  /
      DATA   DTR /    1.7453 292519943D-2  /
      DATA   RTD /   57.29577 951308 2 D0  /
C
C
C         -----------------------------------------
C
      WRITE (*,2000)
2000  FORMAT ( //4X,' Spherical Harmonic over Sphere  (ver 1.0) '//)
C
C                        -----------
C
100   CONTINUE
C
120   CONTINUE
C
      WRITE (*,2002)
2002  FORMAT ( /4X,'ENTER OUTPUT FILE NAME: '\ )
      READ (*,1002) FNOUT
1002  FORMAT ( A )
C
      LUNOUT  = 2
      CLOSE ( LUNOUT )
      OPEN (  LUNOUT, FILE=FNOUT,STATUS='UNKNOWN', IOSTAT=IOCK)
C
      IF ( IOCK.NE.0 ) GOTO 120
C
C              ----------------------------------------------
C
200   CONTINUE
C
      WRITE (*, 2004 )
2004  FORMAT (/4X,'L,M  (.LT.0 EXIT)  = '\)
      READ (*,*) L,M
C
      IF ( L.LT.0 ) GOTO 900
C
      IF ( L.LT.M ) GOTO 200
C
      DTHETA  =  10.0D0
      DPHI    =  20.0D0
      NTHETA  =  19
      NPHI    =  18
C
C
      WRITE (LUNOUT ,2010 ) L,M
2010  FORMAT ('*',4X,'SPHERICAL HARMONIC : ',2I4 / )
C
      THETA  = 0.0D0
C
      DO   400 ITH = 1, NTHETA
C
          THETAR  = DTR * THETA
          X       = DCOS ( THETAR )
C
          CALL PLM ( L,M,X,PLMVAL, ISTPLM )
C
          PHI   =  0.0D0
C
          DO   300 IPH = 1, NPHI
C
              PHIR =  DTR * PHI
              PHIM =  M * PHIR
              CMP  =  DCOS ( PHIM )
              SMP  =  DSIN ( PHIM )
C
              YCOS =   PLMVAL * CMP
              YSIN =   PLMVAL * SMP
C
              WRITE (LUNOUT,2012) THETA, PHI, X, PLMVAL, YCOS, YSIN
2012          FORMAT ( 1X,2F8.1,2X,F10.5,2X,3F15.5 )
C
              PHI  = PHI + DPHI
C
300      CONTINUE
C
         THETA  =  THETA + DTHETA
C
400   CONTINUE
C
C
      WRITE ( LUNOUT, 2019)
2019  FORMAT ('DATAEND'/)
C
C
      GOTO 200
C
900   CONTINUE
C
      CLOSE (LUNOUT )
      END
