$TITLE:'BASIC VECTOR ROUTINES'
      SUBROUTINE ADDVEC (RI1, RI2, A, RO) 
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION RI1(3), RI2(3), RO(3) 
C 
C      ADDS TWO VECTORS TIMES A CONSTANT
C 
      RO(1) = RI1(1) + A*RI2(1) 
      RO(2) = RI1(2) + A*RI2(2) 
      RO(3) = RI1(3) + A*RI2(3) 
      RETURN
      END 
$PAGE
      FUNCTION DOT (R1,R2)
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION R1(3), R2(3)
C 
C      FORMS DOT PRODUCT OF INPUT VECTORS 
C 
      DOT = R1(1) * R2(1) 
      DOT = DOT + R1(2) * R2(2) 
      DOT = DOT + R1(3) * R2(3) 
      RETURN
      END 
$PAGE
      SUBROUTINE CROSS (AI, BI, C)
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION AI(3), BI(3), C(3)
C 
C      FORMS CROSS PROCUCT C= AI X BI 
C 
      C(1) = AI(2)*BI(3) - AI(3)*BI(2)
      C(2) = AI(3)*BI(1) - AI(1)*BI(3)
      C(3) = AI(1)*BI(2) - AI(2)*BI(1)
      RETURN
      END 
$PAGE
      FUNCTION COSVECS (X,Y)
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION X(3), Y(3)
C 
C 
C      FINDS THE COSINE OF THE ANGLE BETWEEN TWO VECTORS. 
C 
      X1 = X(1)   
      Y1 = Y(1) 
C 
      X2 = X(2)   
      Y2 = Y(2) 
C
      X3 = X(3)   
      Y3 = Y(3) 
C 
      RX        = X1*X1 + X2*X2 + X3*X3
      RY        = Y1*Y1 + Y2*Y2 + Y3*Y3
      DOTP      = X1*Y1 + X2*Y2 + X3*Y3 
      DIVSOR    =    DSQRT ( RX*RY)      
      IF ( ABS(DIVSOR).GT.1.0D-38 ) THEN
           COSVECS   = DOTP / DSQRT (RX*RY)
      ELSE
           COSVECS   = 0.0D0
      ENDIF
C 
C    THE FOLLOWING "IF" CHECKS FOR, AND CORRECTS ROUND OFF ERROR. 
C 
      IF( DABS(COSVECS) .GT. 1.0D0 ) COSVECS = DABS(COSVECS)/COSVECS
C
      RETURN
      END 
$PAGE
      SUBROUTINE SCA X VEC (SCA, VECI,VECO )
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION VECI(3), VECO(3)
C 
C      MULTIPLIES SCALOR SCA TIMES VECTOR VECI AND STORES IN VECO 
C 
      VECO(1) = SCA * VECI(1) 
      VECO(2) = SCA * VECI(2) 
      VECO(3) = SCA * VECI(3) 
      RETURN
      END 
$PAGE
      FUNCTION VECMAG (X) 
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION X(3)
C 
C      FINDS THE LENGTH OF A VECTOR 
C 
      VECMAG = DSQRT( X(1)*X(1) + X(2)*X(2) + X(3)*X(3) )
      RETURN
      END 
$PAGE
      SUBROUTINE NORMV (RI,RO)
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION RI(3), RO(3)
C 
C      RO = RI NORMALIZED TO UNIT LENGTH
C 
      R = RI(1)*RI(1) + RI(2)*RI(2) + RI(3)*RI(3) 
      R = DSQRT (R)
      IF ( R.GT.1.0D-38 ) THEN
         RO(1) = RI(1) / R 
         RO(2) = RI(2) / R 
         RO(3) = RI(3) / R 
      ELSE
         RO(1) = 0.0D0
         RO(2) = 0.0D0
         RO(3) = 0.0D0
      ENDIF
      RETURN
      END 
