      PROGRAM X COR
C
C        CROSS CORRELATION USING REAL FFT
C        USE FULL LENGTH TIME GUARD BANDS
C     
C    6-28 90   JRC  FF INPUT / FIX NORMALIZATION IF LEN .NE. 2**N
C
$INCLUDE:'WRDSIZ.INC'
C
C
C
      DIMENSION RDATA ( 8192 ), SAVSPT ( 8192 )
      DIMENSION XCROS ( 8192 ), RDATA2 ( 8192 )
C
      COMMON /FFTS1/ RDATA
      COMMON /FFTS2/ SAVSPT
      COMMON /FFTS3/ RDATA2
      COMMON /FFTS4/ XCROS
C
      CHARACTER * 30   FNIN, FNIN2,FNOUT
C
C     -------------------------------------------------------------
C
C
      WRITE (*,2000 )
2000  FORMAT (//12X,'----CROSS-CORRELATION OF REAL VALUES---- '/)
C
C          OUTPUT POWER OF TWO TABLE FOR OPERATOR
C
      N1 =     1
      N2 =     5
      N3 =     9
      I1 =     2
      I2 =    32
      I3 =   512
C
      WRITE (*,2090)
2090  FORMAT (/20X,'POWERS OF TWO TABLE'/
     $          9X,3('N',3X,'2**N',8X)/ )
C
      DO 50  I = 1 , 4
C
         WRITE (*,2021) N1,I1,N2,I2,N3,I3
2021     FORMAT ( 6X,I4,I7,5X,I4,I7,5X,I4,I7)
         I1 = 2*I1
         I2 = 2*I2
         I3 = 2*I3
         N1 = N1 + 1
         N2 = N2 + 1
         N3 = N3 + 1
C
50    CONTINUE
C
C
C
C          STANDARD FREE FIELD INIT ( IGNORE BLANK, ;* COL 1 )
C
      CALL IFFRSTD
C
C        ----------  GET FILE NAMES AND DATA POSITION  ---------
C
100   CONTINUE
C
      WRITE (*,2001)
2001  FORMAT(/4X,'ENTER INPUT  FILE-1 NAME: '\)
      READ ( *, 1001 ) FNIN
1001  FORMAT ( A )
      IF ( FNIN.EQ.'     ' ) GOTO 100
C
      LUNIN = 1
      OPEN ( LUNIN, FILE=FNIN, STATUS='OLD', IOSTAT=IOCK )
      IF ( IOCK.NE. 0 ) THEN 
           WRITE (*,2101 ) IOCK
2101       FORMAT ( //4X,'OPEN ERROR ',I10,/)
           GOTO 100
      ENDIF
C
105   CONTINUE
C
      WRITE (*,2002)
2002  FORMAT( 4X,'ENTER INPUT  FILE-2 NAME: '\)
      READ ( *, 1002 ) FNIN2
1002  FORMAT ( A )
      IF ( FNIN2.EQ.'     ' ) GOTO 105
C
      LUN2  = 2
      OPEN ( LUN2, FILE=FNIN2, STATUS='OLD', IOSTAT=IOCK )
      IF ( IOCK.NE. 0 ) THEN 
           WRITE (*,2101 ) IOCK
           GOTO 105
      ENDIF
C
C
110   CONTINUE
C
C
      WRITE (*,2003)
2003  FORMAT(4X,'ENTER OUTPUT FILE   NAME: '\)
      READ ( *, 1003 ) FNOUT
1003  FORMAT ( A )
C
      LUNOUT = 3
      OPEN ( LUNOUT, FILE=FNOUT, STATUS='NEW', IOSTAT=IOCK )
      IF ( IOCK.NE. 0 ) THEN 
           WRITE (*,2102 ) IOCK
2102       FORMAT ( //4X,'OPEN ERROR ',I10,/)
           GOTO 110
      ENDIF
C
120   CONTINUE
C
      WRITE (*,2004 )
2004  FORMAT ( /4X,'FILE-1 FIELD NUMBER OF DATA:  '\ )
      READ (*,* ) IFLDN
C
C
      WRITE (*,2005 )
2005  FORMAT (  4X,'FILE-2 FIELD NUMBER OF DATA:  '\ )
      READ (*,* ) IFLDN2
C
C
      WRITE (*,2011)
2011  FORMAT ( /4X,'FILE 1 RECORDS TO SKIP:       '\)
      READ (*,*) NSKIP
C
      IF ( NSKIP.LE.0) GOTO 140
C
      DO 130 ISK = 1, NSKIP
      READ (LUNIN, 1009,END=800,ERR=140) L
1009  FORMAT ( A )
130   CONTINUE
C
140   CONTINUE
C
      WRITE (*,2012)
2012  FORMAT (  4X,'FILE 2 RECORDS TO SKIP:       '\)
      READ (*,*) NSKIP
C
      IF ( NSKIP.LE.0) GOTO 160
C
      DO 150 ISK = 1, NSKIP
      READ (LUN2, 1009,END=800,ERR=140) L
150   CONTINUE
C
160   CONTINUE
C
C
200   CONTINUE
C
      WRITE(*,2006)
2006  FORMAT (/ 4X,'ENTER DT : '\ )
      READ (*,*) DT
      IF ( DT.LE.0.0D0 ) GOTO 200
C
      FSAMPLE =  1.0D0 / DT
C
210   CONTINUE
C
      WRITE (*,2007) 
2007  FORMAT ( 4X,'ENTER POWER OF TWO FOR SIZE ( .LE. 12 ):  ' \)
      READ (*,*) N2
      IF ( N2.LT.0  .OR.  N2.GT.12 ) GOTO 210
C
      WRITE (*,2008)
2008  FORMAT ( 4X,'ENTER NUMBER OF POINTS TO PROCESS :     '\ )
      READ (*,* ) NDO
C
220   CONTINUE
C
      WRITE (*,2009)
2009  FORMAT(4X,'NUMBER TO ENSEMBLE (0 OR 1 NO ENS.) :     '\ )
      READ ( *,*) NENSEM
      IF (NENSEM.LE.0) NENSEM = 0
C
      IENS = 1
      IF ( NENSEM.LE.0 ) IENS = 0
C
C       ------------  INIT AND PROCESS ALL DATA  ----------
C
      NDONE  = 0
      NFFT   = 0
      NREAD  = 0
C
      SUM1  = 0.0D0
      SUM2  = 0.0D0
C
C
C     ------------ TOP OF READ LOOP ONE DATA SET  -----------
C
250   CONTINUE
C
C
      MAXN  = 0
C
      N  = 2**N2
      NG = 2 * N
C
      DO 290 I = 1, NG
      RDATA(I)  = 0.0D0
      RDATA2(I) = 0.0D0
      IF ( IENS.EQ.1) SAVSPT(I) = 0.0D0
290   CONTINUE
C      
C
       NPTS  = 0
       IEOF  = 0
C
C     -----------------------------------------------------------
C                TOP OF READ LOOP NEW POINTS
C
300   CONTINUE
C
      CALL RDFFX ( LUNIN, IFLDN, RDIN, ISTAT )
      IF ( ISTAT.EQ.-1 ) GOTO 800
      IF ( ISTAT.NE.0 ) GOTO 700
C
C
      CALL RDFFX ( LUN2, IFLDN2, RDIN2, ISTAT )
      IF ( ISTAT.EQ.-1 ) GOTO 800
      IF ( ISTAT.NE.0 ) GOTO 700
C
      NPTS  = NPTS + 1
      NREAD = NREAD + 1
C
      SUM1  = SUM1 + RDIN**2
      SUM2  = SUM2 + RDIN2**2
C
      RDATA(NPTS)  = RDIN
      RDATA2(NPTS) = RDIN2
C
      IF ( NPTS.LT. N ) GOTO 300
      IF ( NREAD.GT.NDO ) GOTO 800
C
C           ---------  PROCESS CURRENT SET NOW READ  ---------
C
400   CONTINUE
C
C        FIND LEAST POWER OF TWO .GT. DATA SIZE
C
      IF ( NPTS.EQ.N ) GOTO 420
C
      NH = N/2
      IF ( NH .LT. NPTS ) GOTO 420
      N  =  NH
      GOTO 400
C
420   CONTINUE
C
      IF ( NPTS.GT.MAXN ) MAXN = NPTS
C
      NG  = 2 * N
      DF  = 0.5 * FSAMPLE / NG
      NH  = NG/2
C
C     ---------------------------------
      CALL RFFT ( RDATA, NG, 1 )
      CALL RFFT ( RDATA2,NG, 1 )
C     ---------------------------------
C
C           FORM  F*CONJUGATE(G)
C
         ISB  = 1
         DO 430 IS = ISB, NH
C
            IX  =   2*IS - 1
C
            FR  =   RDATA(IX)
            FI  =   RDATA(IX+1)
            GR  =   RDATA2(IX)
            GI  =  - RDATA2(IX+1)
C
            FGR  =  FR*GR - FI*GI
            FGI  =  FR*GI + FI*GR
C
            XCROS(IX)    =  FGR  
            XCROS(IX+1)  =  FGI  
C
C
430      CONTINUE
C
C
         XCROS(1)  =  RDATA(1)*RDATA2(1)
         XCROS(2)  =  RDATA(2)*RDATA2(2)
C
C
C           ----  IF ENSEMBLE ADD INTO SAVE ARRAY    ----
C
      IF ( IENS.NE.0 ) THEN
C
         IX = 3
         DO 440 IS = 1, NH
C
            XR    =  XCROS ( IX )
            XI     = XCROS ( IX+1 )
C
            SAVSPT(IX)    =  XR*XR + XI*XI  +  SAVSPT(IX)
C
            IX = IX + 2
C
440      CONTINUE
C
         SAVSPT(1)  = SAVSPT(1) + XCROS(1)*XCROS(1)
         SAVSPT(2)  = SAVSPT(2) + XCROS(2)*XCROS(2)
C
         IF ( IENS.EQ.NENSEM ) GOTO 460
         IF (IEOF.NE.0 ) GOTO 460
         IENS  = IENS + 1
         GOTO 250
C
      ENDIF
C
C        ----------  FINAL PROCESSING -- ONE DATA SET OR   -------
C                    SPECIFIED NUMBER OF ENSEMBLED SETS
C
460   CONTINUE
C
C
      FNENS = IENS
C
      DO 470 IS = 1, NG
C
         IF ( NENSEM.NE.0 ) THEN        
            RDATA(IS) = DSQRT ( SAVSPT(IS)/FNENS )
         ELSE
            RDATA(IS) = XCROS(IS)
         ENDIF
C 
470   CONTINUE
C
      IF ( NENSEM.NE.0 ) IENS  = 1
C
C   ------------- RESET ARRAYS TO MAGNITUDE AND X-FORM -------
C                      IN FREQ DOMAIN
C
      FNH      = NH
C
C
C         ---------  BACK TO TIME DOMAIN   ---------
C
C     -----------------------------
      CALL RFFT ( RDATA, NG, -1 )
C     ----------------------------
C
      RTD    =  360.D0/6.2831853071D0
C
C
C      SAVE + CORRECT 0 FREQ ITEM
C
      A1        = RDATA(2)
C
      DTN  = DT
      TAU  = 0.0
C
C        ADJUST FOR PARTIALLY FILLED ARRAY
C
      FNPT   =  MAXN
      FN     =  N
      VARADJ =  FNPT/FN
C
      FNRD  = NPTS
      RMS1  = DSQRT ( SUM1/FNRD )
      RMS2  = DSQRT ( SUM2/FNRD )
C
      RMS   =   DSQRT( DABS ( RMS1*RMS2) )
C
      SQ2   =  DSQRT ( 2.0D0 )
      FNOR  =  1.0D0 / RMS**2
C
C    -----------------------------------------------------
C               OUTPUT  NORMALIZED AUTOCOR.
C
C
      DO  500  IC = 1, MAXN
C
      X    =  FNOR * RDATA ( IC )
C
      FNUSE  = MAXN - IC + 1
      ENOR   = FNPT / FNUSE
C
      AMP  = ENOR * X
C
      IF ( IC.EQ.1 ) THEN
         WRITE ( LUNOUT,2020 ) TAU,AMP,RMS
      ELSE
         WRITE ( LUNOUT, 2020 ) TAU, AMP
2020     FORMAT( F15.6,F15.6,E15.5)
      ENDIF
C
C
      TAU    =   TAU + DTN
C
500   CONTINUE
C
C    -------------------------------------------
C
      NFFT = NFFT + 1
      WRITE (*,2031 ) NFFT, N, RMS
2031  FORMAT (/4X,I4,' TH A-COR, ',I7,' PTS, ',E12.4,' RMS')
C
C
      SUM1  = 0.0D0
      SUM2  = 0.0D0
C
C
      IF ( IEOF .NE. 0 ) GOTO 900
C
      NDONE = NDONE + NPTS
      IF ( NDONE.LT.NDO ) GOTO 250
C
      GOTO 900
C
C    ------------------------------------------------------------
C
C           ERROR CONDITION
C
700   CONTINUE
C
      WRITE (*,2110 ) NPTS + 1
2110  FORMAT ( //4X,'ERROR ON READ ',I5/)
C
C           END OF FILE
C
800   CONTINUE
C
      IEOF  = 1
      IF ( NPTS.LE.4 ) GOTO 900
      GOTO 400
C
C
900   CONTINUE
C
C
      CLOSE ( LUNIN )
      CLOSE ( LUNOUT )
C
      END
